RAD = math.pi/180

-- Set up autopilot structures
apparam={}

wing ={}

minimum_distance_for_wing = 500

hardcoded_dalt_to_slope = 1e-2 ----hardcoded factor between alt to climb/desc and slope: 1000m sets 10 dg slope
discard_step_simdt_criteria = 2.5 --proportion between current step time and the mean value from earlier steps for which the process is skipped to avoid jumps and hickups in sim to affect the autopilot.

hplanet = vessel.get_focusinterface():get_surfaceref()

DEBUG = {
	squadron = nil,
	wingman = nil,
	mode = ''
}


--*******************************************************************
--User Functions
--*******************************************************************


function p()

	--clearing terminal-- still trying --UNDOCUMENTED
	term.out(string.char(12))
	local terminx =0
	while terminx < 30 do
		term.out(string.char(13))
		terminx =terminx+1
	end
	term.out(string.char(12))
	--term.clear()
end


function cs(leaderstr)

	local sqdinx = 0
	local vsslinx =0
	local thisleadervi = nil

	--this inits all aap variables concerning a leader in focus and associated planes in a squadron considering the class name ,allowing for 2 characters suffix variations.

	--finding a new squadron number
	while wing[sqdinx] ~= nil do
			if wing[sqdinx][0].procID == -1 then break end
			sqdinx =sqdinx+1
	end

	--leader given by name (valid?) or the one in focus?
	if leaderstr == nil then
		thisleadervi = vessel.get_focusinterface()
		if findme() ~= nil then
			term.out('Plane busy. Cannot create squadron. Exclude plane from its assignment first')
			return
		end
	else
		thisleadervi = vessel.get_interface(leaderstr)
		if thisleadervi == nil then 
			term.out('Invalid vessel name. No such vessel in this scenario.')
			return
		end
		if findme(thisleadervi) ~= nil then 
			term.out('Plane busy. Cannot create squadron. Exclude plane from its assignment first')
			return
		end
	end

	term.out('Creating squadron #'..tostring(sqdinx)..'.')

	wing[sqdinx]= {}
	wing[sqdinx][0]={}
	wing[sqdinx][0].vi= thisleadervi
	wing[sqdinx][0].hi = wing[sqdinx][0].vi:get_handle()
	apparam[sqdinx] = {} 
	apparam[sqdinx].stdclassname = string.lower(wing[sqdinx][0].vi:get_classname())
	if not getparameters(apparam[sqdinx].stdclassname,sqdinx)  then
		wing[sqdinx]= nil
		term.out('Could not create squadron. Autopilot parameter file not found.')
		return
	end
	
	if apparam[sqdinx].category == 'HTOL' then
		Hcs(sqdinx,vsslinx)  
	elseif apparam[sqdinx].category == 'VTOL' then
		Vcs(sqdinx,vsslinx)
	else
		term.out('Vessel Category \''..apparam[sqdinx].category..'\' not recognized: should be VTOL or HTOL')
		return
	end
	
end

function Hcs(sqdinx,vsslinx)                --(leaderstr)

	term.out('Squadron #'..tostring(sqdinx)..' is a HTOL squadron.')
	
	wing[sqdinx][0].Formseq = {0,0}
	wing[sqdinx][0].pitch0 =0
	wing[sqdinx][0].dslope0 = 0
	wing[sqdinx][0].spd0 = 0
	wing[sqdinx][0].hdg0 = 0
	wing[sqdinx][0].bnk0 = 0
	wing[sqdinx][0].ptc0 = 0
	wing[sqdinx][0].alt0 = 0
	wing[sqdinx][0].terhgt0 = 0
	wing[sqdinx][0].yaw0 = 0
	wing[sqdinx][0].dyaw0 = 0
	wing[sqdinx][0].formdz0 = 0 -- never used
	wing[sqdinx][0].formdx0 = 0 -- never used
	wing[sqdinx][0].elevcomm = wing[sqdinx][0].vi:get_adclevel(AIRCTRL.ELEVATOR)
	wing[sqdinx][0].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)
	wing[sqdinx][0].tgtspd = wing[sqdinx][0].vi:get_airspeed()
	wing[sqdinx][0].tgtbnk = wing[sqdinx][0].vi:get_bank()
	wing[sqdinx][0].tgtptc = wing[sqdinx][0].vi:get_pitch()
	wing[sqdinx][0].tgthdg = wing[sqdinx][0].vi:get_yaw()*180/math.pi
	wing[sqdinx][0].tgtslope = 0
	wing[sqdinx].Forminterval = 50
	wing[sqdinx].Formangle = 30
	wing[sqdinx].headrate = 0
	wing[sqdinx].trfpatstatus = -1
	wing[sqdinx].trfpattime = 0
	wing[sqdinx].trfpatelpsdtime = 0
	wing[sqdinx].trfpatorghead = wing[sqdinx][0].tgthdg
	wing[sqdinx].crswpinx = -1
	wing[sqdinx].crswpnum = -1
	wing[sqdinx].crsmod = 'none'
	wing[sqdinx].crswpmod = -1
	wing[sqdinx].gearsts =0  --0 unknown,-1 retracted,1 deployed
	DisableAllInternalAPs(sqdinx,0)
	wing[sqdinx][0].procID = proc.bg(wkp,sqdinx,0)
	wing[sqdinx].count = 1
	term.out('Focus vessel '..wing[sqdinx][0].vi:get_name()..' set as squadron #'..tostring(sqdinx)..' leader.')
	local vsslinx=0
	local wgmainx = 1
	while vsslinx < vessel.get_count() do
		local vthisvssl = vessel.get_interface(vsslinx)
		local thivsslclss= string.lower(vthisvssl:get_classname())
		if vthisvssl ~= wing[sqdinx][0].vi then
			local fcusclssnme = apparam[sqdinx].stdclassname
			local lgrclssnme = #thivsslclss 
			if #fcusclssnme < lgrclssnme then
				lgrclssnme = lgrclssnme - 2
			end
			if (string.sub(thivsslclss,1,lgrclssnme) == string.sub(fcusclssnme,1,lgrclssnme)) and (vec.length(vec.sub(wing[sqdinx][0].vi:get_globalpos(), vthisvssl:get_globalpos()))< minimum_distance_for_wing)  then 
				if findme(vthisvssl) ~= nil then
					term.out('Plane '..vthisvssl:get_name()..'is busy. Cannot assign it to this squadron.')
				else
					wing[sqdinx][wgmainx] = {}
					wing[sqdinx][wgmainx].vi = vthisvssl
					wing[sqdinx][wgmainx].hi = wing[sqdinx][wgmainx].vi:get_handle()
					wing[sqdinx][wgmainx].Formseq = {0,0}
					wing[sqdinx][wgmainx].pitch0 =0
					wing[sqdinx][wgmainx].dslope0 = 0
					wing[sqdinx][wgmainx].spd0 = 0
					wing[sqdinx][wgmainx].hdg0 = 0
					wing[sqdinx][wgmainx].bnk0 = 0
					wing[sqdinx][wgmainx].ptc0 = 0
					wing[sqdinx][wgmainx].alt0 = 0
					wing[sqdinx][wgmainx].terhgt0 = 0
					wing[sqdinx][wgmainx].yaw0 = 0
					wing[sqdinx][wgmainx].dyaw0 = 0
					wing[sqdinx][wgmainx].formdz0 = 0
					wing[sqdinx][wgmainx].formdx0 = 0
					wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.ELEVATOR)
					wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].tgtalt
					wing[sqdinx][wgmainx].tgtspd = wing[sqdinx][0].tgtspd
					wing[sqdinx][wgmainx].tgtbnk = wing[sqdinx][0].tgtbnk
					wing[sqdinx][wgmainx].tgtptc = wing[sqdinx][0].tgtptc
					wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][0].tgthdg
					wing[sqdinx][wgmainx].tgtslope = 0
					DisableAllInternalAPs(sqdinx,wgmainx)
					wing[sqdinx][wgmainx].procID = proc.bg(wkp,sqdinx,wgmainx)
					wing[sqdinx].count = wgmainx + 1
					term.out( wing[sqdinx][wgmainx].vi:get_name()..' set as squadron #'..tostring(sqdinx)..', wingman #'..tostring(wgmainx)..'.')
					wgmainx = wgmainx+1
				end
			end
		end
		vsslinx =vsslinx+1
	end
	sf('wedge',sqdinx)
end

function Vcs(sqdinx,vsslinx)   --(leaderstr)

	term.out('Squadron #'..tostring(sqdinx)..' is a VTOL squadron.')
	
	wing[sqdinx][0].Formseq = {0,0}
	wing[sqdinx][0].pitch0 =0
	wing[sqdinx][0].dslope0 = 0
	wing[sqdinx][0].spd0 = 0
	wing[sqdinx][0].hdg0 = 0
	wing[sqdinx][0].bnk0 = 0
	wing[sqdinx][0].ptc0 = 0
	wing[sqdinx][0].alt0 = 0
	wing[sqdinx][0].terhgt0 = 0
	wing[sqdinx][0].yaw0 = 0
	wing[sqdinx][0].dyaw0 = 0
	wing[sqdinx][0].formdz0 = 0 -- never used
	wing[sqdinx][0].formdx0 = 0 -- never used
	wing[sqdinx][0].elevcomm = wing[sqdinx][0].vi:get_adclevel(AIRCTRL.ELEVATOR)
	wing[sqdinx][0].ciclicptc = 0 
	wing[sqdinx][0].ciclicbnk =0
	wing[sqdinx][0].secrotyaw = 0
	wing[sqdinx][0].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)
	wing[sqdinx][0].tgtspd = wing[sqdinx][0].vi:get_airspeed()
	wing[sqdinx][0].tgtbnk = wing[sqdinx][0].vi:get_bank()
	wing[sqdinx][0].tgtptc = wing[sqdinx][0].vi:get_pitch()
	wing[sqdinx][0].tgthdg = wing[sqdinx][0].vi:get_yaw()*180/math.pi
	wing[sqdinx][0].tgtslope = 0
	wing[sqdinx].Forminterval = 50
	wing[sqdinx].Formangle = 30
	wing[sqdinx].headrate = 0
	wing[sqdinx].trfpatstatus = -1
	wing[sqdinx].trfpattime = 0
	wing[sqdinx].trfpatelpsdtime = 0
	wing[sqdinx].trfpatorghead = wing[sqdinx][0].tgthdg
	wing[sqdinx].crswpinx = -1
	wing[sqdinx].crswpnum = -1
	wing[sqdinx].crsmod = 'none'
	wing[sqdinx].crswpmod = -1
	wing[sqdinx].gearsts =0  --0 unknown,-1 retracted,1 deployed
	DisableAllInternalAPs(sqdinx,0)
	wing[sqdinx][0].procID = proc.bg(Vwkp,sqdinx,0)
	wing[sqdinx].count = 1
	term.out('Focus vessel '..wing[sqdinx][0].vi:get_name()..' set as squadron #'..tostring(sqdinx)..' leader.')
	local vsslinx=0
	local wgmainx = 1
	while vsslinx < vessel.get_count() do
		local vthisvssl = vessel.get_interface(vsslinx)
		local thivsslclss= string.lower(vthisvssl:get_classname())
		if vthisvssl ~= wing[sqdinx][0].vi then
			local fcusclssnme = apparam[sqdinx].stdclassname
			local lgrclssnme = #thivsslclss 
			if #fcusclssnme < lgrclssnme then
				lgrclssnme = lgrclssnme - 2
			end
			if (string.sub(thivsslclss,1,lgrclssnme) == string.sub(fcusclssnme,1,lgrclssnme)) and (vec.length(vec.sub(wing[sqdinx][0].vi:get_globalpos(), vthisvssl:get_globalpos()))< minimum_distance_for_wing)  then 
				if findme(vthisvssl) ~= nil then
					term.out('Plane '..vthisvssl:get_name()..'is busy. Cannot assign it to this squadron.')
				else
					wing[sqdinx][wgmainx] = {}
					wing[sqdinx][wgmainx].vi = vthisvssl
					wing[sqdinx][wgmainx].hi = wing[sqdinx][wgmainx].vi:get_handle()
					wing[sqdinx][wgmainx].Formseq = {0,0}
					wing[sqdinx][wgmainx].pitch0 =0
					wing[sqdinx][wgmainx].dslope0 = 0
					wing[sqdinx][wgmainx].spd0 = 0
					wing[sqdinx][wgmainx].hdg0 = 0
					wing[sqdinx][wgmainx].bnk0 = 0
					wing[sqdinx][wgmainx].ptc0 = 0
					wing[sqdinx][wgmainx].alt0 = 0
					wing[sqdinx][wgmainx].terhgt0 = 0
					wing[sqdinx][wgmainx].yaw0 = 0
					wing[sqdinx][wgmainx].dyaw0 = 0
					wing[sqdinx][wgmainx].formdz0 = 0
					wing[sqdinx][wgmainx].formdx0 = 0
					wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.ELEVATOR)
					wing[sqdinx][wgmainx].ciclicptc = 0
					wing[sqdinx][wgmainx].ciclicbnk = 0
					wing[sqdinx][wgmainx].secrotyaw = 0
					wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].tgtalt
					wing[sqdinx][wgmainx].tgtspd = wing[sqdinx][0].tgtspd
					wing[sqdinx][wgmainx].tgtbnk = wing[sqdinx][0].tgtbnk
					wing[sqdinx][wgmainx].tgtptc = wing[sqdinx][0].tgtptc
					wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][0].tgthdg
					wing[sqdinx][wgmainx].tgtslope = 0
					DisableAllInternalAPs(sqdinx,wgmainx)
					wing[sqdinx][wgmainx].procID = proc.bg(Vwkp,sqdinx,wgmainx)
					wing[sqdinx].count = wgmainx + 1
					term.out( wing[sqdinx][wgmainx].vi:get_name()..' set as squadron #'..tostring(sqdinx)..', wingman #'..tostring(wgmainx)..'.')
					wgmainx = wgmainx+1
				end
			end
		end
		vsslinx =vsslinx+1
	end
	sf('wedge',sqdinx)
end

function ks(sqdinx)
--this function kills a formation killing all related processes , liberating all slots and setting count number to zero

	local kinx = 0
	if sqdinx==nil then term.out('You should specify a squadron number.') return end
	if wing[sqdinx] == nil then term.out('Invalid squadron number.') return end

	term.out('Squadron #'..tostring(sqdinx) ..' will be disbanded') 
	while kinx< wing[sqdinx].count do
		proc.kill(wing[sqdinx][kinx].procID)
		wing[sqdinx][kinx].procID = -1
		term.out('Plane '..wing[sqdinx][kinx].vi:get_name()..' is dismissed.')
		kinx=kinx+1
	end
	wing[sqdinx].count = 0
	if wing[sqdinx + 1] == nil then wing[sqdinx] = nil end
end


function cf(leaderstr)

	--this inits all aap variables concerning a leader in focus but do not search for wingmen. Therefore its suitable for single plane autopiloting such as tankers

	local sqdinx = 0
	local vsslinx =0
	local thisleadervi = nil

	--this inits all aap variables concerning a leader in focus and associated planes in a squadron considering the class name ,allowing for 2 characters suffix variations.

	--finding a new squadron number
	while wing[sqdinx] ~= nil do
			if wing[sqdinx][0].procID == -1 then break end
			sqdinx =sqdinx+1
	end

	--leader given by name (valid?) or the one in focus?
	if leaderstr == nil then
		thisleadervi = vessel.get_focusinterface()
		if findme() ~= nil then
			term.out('Plane busy. Cannot create flight. Exclude plane from its assignment first')
			return
		end
	else
		thisleadervi = vessel.get_interface(leaderstr)
		if thisleadervi == nil then 
			term.out('Invalid vessel name. No such vessel in this scenario.')
			return
		end
		if findme(thisleadervi) ~= nil then 
			term.out('Plane busy. Cannot create flight. Exclude plane from its assignment first')
			return
		end
	end

	term.out('Creating single unit squadron '..tostring(sqdinx)..' : a flight. You can add wingmen to this squadron later with ps('..tostring(sqdinx)..').')

	wing[sqdinx]= {}
	wing[sqdinx][0]={}
	wing[sqdinx][0].vi = thisleadervi
	wing[sqdinx][0].hi = wing[sqdinx][0].vi:get_handle()
	apparam[sqdinx] = {} 
	apparam[sqdinx].stdclassname = string.lower(wing[sqdinx][0].vi:get_classname())
	if not getparameters(apparam[sqdinx].stdclassname,sqdinx)  then
		wing[sqdinx]= nil
		term.out('Could not create flight. Autopilot parameter file not found.')
		return
	end

	if apparam[sqdinx].category == 'HTOL' then
		Hcf(sqdinx,vsslinx)  
	elseif apparam[sqdinx].category == 'VTOL' then
		Vcf(sqdinx,vsslinx)
	else
		term.out('Vessel Category \''..apparam[sqdinx].category..'\' not recognized: should be VTOL or HTOL')
		return
	end
	
end


function Hcf(sqdinx,vsslinx)       --(leaderstr)

	term.out('Flight #'..tostring(sqdinx)..' is a HTOL flight.')
	
	wing[sqdinx][0].Formseq = {0,0}
	wing[sqdinx][0].pitch0 =0
	wing[sqdinx][0].dslope0 = 0
	wing[sqdinx][0].spd0 = 0
	wing[sqdinx][0].hdg0 = 0
	wing[sqdinx][0].bnk0 = 0
	wing[sqdinx][0].ptc0 = 0
	wing[sqdinx][0].alt0 = 0
	wing[sqdinx][0].terhgt0 = 0
	wing[sqdinx][0].yaw0 = 0
	wing[sqdinx][0].dyaw0 = 0
	wing[sqdinx][0].formdz0 = 0 -- never used
	wing[sqdinx][0].formdx0 = 0 -- never used
	wing[sqdinx][0].elevcomm = wing[sqdinx][0].vi:get_adclevel(AIRCTRL.ELEVATOR)
	wing[sqdinx][0].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)
	wing[sqdinx][0].tgtspd = wing[sqdinx][0].vi:get_airspeed()
	wing[sqdinx][0].tgtbnk = wing[sqdinx][0].vi:get_bank()
	wing[sqdinx][0].tgtptc = wing[sqdinx][0].vi:get_pitch()
	wing[sqdinx][0].tgthdg = wing[sqdinx][0].vi:get_yaw()*180/math.pi
	wing[sqdinx][0].tgtslope = 0
	wing[sqdinx].Forminterval = 50
	wing[sqdinx].Formangle = 30
	wing[sqdinx].headrate = 0
	wing[sqdinx].trfpatstatus = -1
	wing[sqdinx].trfpattime = 0
	wing[sqdinx].trfpatelpsdtime = 0
	wing[sqdinx].trfpatorghead = wing[sqdinx][0].tgthdg
	wing[sqdinx].crswpnum = -1
	wing[sqdinx].crsmod = 'none'
	wing[sqdinx].crswpmod = -1
	wing[sqdinx].crswpinx = -1
	wing[sqdinx].gearsts =0
	DisableAllInternalAPs(sqdinx,0)
	wing[sqdinx][0].procID = proc.bg(wkp,sqdinx,0)
	wing[sqdinx].count = 1
	term.out('Focus vessel '..wing[sqdinx][0].vi:get_name()..' set as squadron #'..tostring(sqdinx)..' single unit and leader (flight).')




end

function Vcf(sqdinx,vsslinx) 

	term.out('Flight #'..tostring(sqdinx)..' is a VTOL flight.')
	
	wing[sqdinx][0].Formseq = {0,0}
	wing[sqdinx][0].pitch0 =0
	wing[sqdinx][0].dslope0 = 0
	wing[sqdinx][0].spd0 = 0
	wing[sqdinx][0].hdg0 = 0
	wing[sqdinx][0].bnk0 = 0
	wing[sqdinx][0].ptc0 = 0
	wing[sqdinx][0].alt0 = 0
	wing[sqdinx][0].terhgt0 = 0
	wing[sqdinx][0].yaw0 = 0
	wing[sqdinx][0].dyaw0 = 0
	wing[sqdinx][0].formdz0 = 0 -- never used
	wing[sqdinx][0].formdx0 = 0 -- never used
	wing[sqdinx][0].elevcomm = wing[sqdinx][0].vi:get_adclevel(AIRCTRL.ELEVATOR)
	wing[sqdinx][0].ciclicptc = 0
	wing[sqdinx][0].ciclicbnk = 0
	wing[sqdinx][0].secrotyaw = 0
	wing[sqdinx][0].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)
	wing[sqdinx][0].tgtspd = wing[sqdinx][0].vi:get_airspeed()
	wing[sqdinx][0].tgtbnk = wing[sqdinx][0].vi:get_bank()
	wing[sqdinx][0].tgtptc = wing[sqdinx][0].vi:get_pitch()
	wing[sqdinx][0].tgthdg = wing[sqdinx][0].vi:get_yaw()*180/math.pi
	wing[sqdinx][0].tgtslope = 0
	wing[sqdinx].Forminterval = 50
	wing[sqdinx].Formangle = 30
	wing[sqdinx].headrate = 0
	wing[sqdinx].trfpatstatus = -1
	wing[sqdinx].trfpattime = 0
	wing[sqdinx].trfpatelpsdtime = 0
	wing[sqdinx].trfpatorghead = wing[sqdinx][0].tgthdg
	wing[sqdinx].crswpnum = -1
	wing[sqdinx].crsmod = 'none'
	wing[sqdinx].crswpmod = -1
	wing[sqdinx].crswpinx = -1
	wing[sqdinx].gearsts =0
	DisableAllInternalAPs(sqdinx,0)
	wing[sqdinx][0].procID = proc.bg(Vwkp,sqdinx,0)
	wing[sqdinx].count = 1
	term.out('Focus vessel '..wing[sqdinx][0].vi:get_name()..' set as squadron #'..tostring(sqdinx)..' single unit and leader (flight).')




end

function ps(sqdinx,wgmainx,frmsq)

	if sqdinx == nil then term.out('Squadron number must be defined.') return end

	local cnddtevif = vessel.get_focusinterface()
	if findme(cnddtevif) ~= nil then
		term.out('Plane '..cnddtevif:get_name()..' is busy. Cannot assign it to a new squadron.')
		return
	end

	--include in information


			if wgmainx == nil then wgmainx = wing[sqdinx].count end

			term.out('Including focus plane in squadron #'..tostring(sqdinx)..' as wingman #'..tostring(wgmainx)..'.') 

			if wgmainx == wing[sqdinx].count  then
				wing[sqdinx][wgmainx] = {}
				wing[sqdinx].count = wing[sqdinx].count +1
				wing[sqdinx][wgmainx].procID = -1
				wing[sqdinx][wgmainx].vi = nil
				wing[sqdinx][wgmainx].Formseq ={}
				if frmsq == nil then
					local fone = 1
					if wing[sqdinx][wgmainx-1].Formseq[1] ~= 0 then fone = wing[sqdinx][wgmainx-1].Formseq[1]/wing[sqdinx][wgmainx-1].Formseq[1] end
					wing[sqdinx][wgmainx].Formseq[1] = wing[sqdinx][wgmainx-1].Formseq[1] + 2 * fone
					wing[sqdinx][wgmainx].Formseq[2] = wing[sqdinx][wgmainx-1].Formseq[2] - 2 
					term.out('Arrival formation position for the new wingman is  {'..tostring(wing[sqdinx][wgmainx].Formseq[1])..','..tostring(wing[sqdinx][wgmainx].Formseq[2])..'}. Redefine formation to assign a proper position.')
				else
					wing[sqdinx][wgmainx].Formseq[1] = frmsq[1]
					wing[sqdinx][wgmainx].Formseq[2] = frmsq[2]
				end

			elseif wgmainx > wing[sqdinx].count then
				term.out('No such squadron slot. Currently squadron has '..tostring(wing[sqdinx].count)..' elements. Do not specify slot for next one.')
				return
			end

			if wing[sqdinx][wgmainx].procID ~= -1 then term.out('Squadron slot is busy.') return end

			wing[sqdinx][wgmainx].vi = vessel.get_focusinterface()
			wing[sqdinx][wgmainx].hi = wing[sqdinx][wgmainx].vi:get_handle()
			wing[sqdinx][wgmainx].pitch0 =0
			wing[sqdinx][wgmainx].dslope0 = 0
			wing[sqdinx][wgmainx].spd0 = 0
			wing[sqdinx][wgmainx].hdg0 = 0
			wing[sqdinx][wgmainx].bnk0 = 0
			wing[sqdinx][wgmainx].ptc0 = 0
			wing[sqdinx][wgmainx].alt0 = 0
			wing[sqdinx][wgmainx].terhgt0 = 0
			wing[sqdinx][wgmainx].yaw0 = 0
			wing[sqdinx][wgmainx].dyaw0 = 0
			wing[sqdinx][wgmainx].formdz0 = 0
			wing[sqdinx][wgmainx].formdx0 = 0
			wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.ELEVATOR)
			wing[sqdinx][wgmainx].ciclicptc = 0
			wing[sqdinx][wgmainx].ciclicbnk = 0
			wing[sqdinx][wgmainx].secrotyaw = 0
			wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].tgtalt
			wing[sqdinx][wgmainx].tgtspd = wing[sqdinx][0].tgtspd
			wing[sqdinx][wgmainx].tgtbnk = wing[sqdinx][0].tgtbnk
			wing[sqdinx][wgmainx].tgtptc = wing[sqdinx][0].tgtptc
			wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][0].tgthdg
			wing[sqdinx][wgmainx].tgtslope = 0
			DisableAllInternalAPs(sqdinx,wgmainx)
			if apparam[sqdinx].category == 'HTOL' then
				Hps(sqdinx,wgmainx,frmsq)
			elseif apparam[sqdinx].category == 'VTOL' then
				Vps(sqdinx,wgmainx,frmsq)
			end

end

function Hps(sqdinx,wgmainx,frmsq)

			wing[sqdinx][wgmainx].procID= proc.bg(wkp,sqdinx,wgmainx)
			term.out( wing[sqdinx][wgmainx].vi:get_name()..' included in HTOL squadron #'..tostring(sqdinx)..', as wingman #'..tostring(wgmainx)..'.')

end

function Vps(sqdinx,wgmainx,frmsq)

			wing[sqdinx][wgmainx].procID= proc.bg(Vwkp,sqdinx,wgmainx)
			term.out( wing[sqdinx][wgmainx].vi:get_name()..' included in VTOL squadron #'..tostring(sqdinx)..', as wingman #'..tostring(wgmainx)..'.')

end

function xs(sqdinx,wgmainx)
	--this function takes out a given element from a given squadron and kills its processes

	term.out('Excluding focus or argument plane from squadron...')

	if (sqdinx == nil and wgmainx ~=nil) or (sqdinx ~= nil and wgmainx ==nil)  then term.out('Invalid arguments. Specify both squadron and wingman or none to exclude focus plane.') return end

	if sqdinx == nil then
		sqdinx,wgmainx = findme(vessel.get_focusinterface())
	else
		if wing[sqdinx] == nil then term.out ('No such squadron exist.') return end
		if wgmainx == 0 then term.out('Cannot exclude the leader. Use ks() to deassign the whole squadron.') return end
		if wgmainx >= wing[sqdinx].count then term.out('No such wingman in squadron #'..tostring(sqdinx)..'.') return end
	end

	proc.kill(wing[sqdinx][wgmainx].procID)
	wing[sqdinx][wgmainx].procID = -1
	
	--Specific VTOL, HTOL measures
	if apparam[sqdinx].category == 'HTOL' then
		Hxs(sqdinx,wgmainx)
	elseif apparam[sqdinx].category == 'VTOL' then
		Vxs(sqdinx,wgmainx)
	end
	
	
	term.out( wing[sqdinx][wgmainx].vi:get_name()..' was excluded from squadron #'..tostring(sqdinx)..', wingman #'..tostring(wgmainx)..' slot is now empty.')
	wing[sqdinx][wgmainx].vi = nil

end

function Hxs(sqdinx,wgmainx)

--Specific HTOL measures

end

function Vxs(sqdinx,wgmainx)

--Specific VTOL measures

	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_PITCHUP,0)
	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_PITCHDOWN,0)
	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_BANKLEFT,0)
	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_BANKRIGHT,0)
	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWLEFT,0)
	wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWRIGHT,0)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.HOLDALT,true)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.HLEVEL,true)

end

function ls(sqdinx)
	--this function shows all settings for the wing
	if sqdinx== nil then
		sqdinx = findme()
		if sqdinx == nil then term.out('This plane is not part of a squadron.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	term.out('Showing settings for squadron #'..tostring(sqdinx)..':')
	term.out('This is a '..apparam[sqdinx].category..' squadron.')
	term.out('Altitude: '..tostring(wing[sqdinx][0].tgtalt)..'m.')
	term.out('Speed:'..tostring(wing[sqdinx][0].tgtspd)..'m/s.')
	local hdg2dsp = wing[sqdinx][0].tgthdg
	if hdg2dsp < 0 then hdg2dsp =  hdg2dsp +2 * math.pi end
	term.out('Heading:'..tostring(hdg2dsp)..string.char(176)..'.')
	term.out('Squadron #'..tostring(sqdinx)..' has '..tostring(wing[sqdinx].count)..' element(s).')
	term.out('Formation distance for squadron #'..tostring(sqdinx)..' is '..tostring(wing[sqdinx].Forminterval)..'m.')
	term.out('Formation angle for squadron #'..tostring(sqdinx)..' is '..tostring(wing[sqdinx].Formangle)..string.char(176)..'.')
	term.out('Squadron leader is '..wing[sqdinx][0].vi:get_name()..'.')
	sfinx = 1
	while sfinx < wing[sqdinx].count do
		if wing[sqdinx][sfinx].vi ~= nil then
			term.out('Wingman #'..tostring(sfinx)..' is '..wing[sqdinx][sfinx].vi:get_name()..'.')
			term.out('Its formation position is {'..tostring(wing[sqdinx][sfinx].Formseq[1])..','..tostring(wing[sqdinx][sfinx].Formseq[2])..'}.')
		else
			term.out('Wingman #'..tostring(sfinx)..' slot is empty.')
		end
		sfinx =sfinx+1
	end
end

function lp(sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	term.out('Showing autopilot parameters for squadron #'..tostring(sqdinx)..'.')

	term.out('Original parameter file class was '..apparam[sqdinx].stdclassname..'.apm.')

	term.out('apparam[sqdinx].category='..tostring(apparam[sqdinx].category))
	term.out('apparam[sqdinx].alt.damp='..tostring(apparam[sqdinx].alt.damp))
	term.out('apparam[sqdinx].alt.gain='..tostring(apparam[sqdinx].alt.gain))
	term.out('apparam[sqdinx].spd.damp='..tostring( apparam[sqdinx].spd.damp))
	term.out('apparam[sqdinx].spd.gain='..tostring( apparam[sqdinx].spd.gain))
	term.out('apparam[sqdinx].bank.damp='..tostring(apparam[sqdinx].bank.damp))
	term.out('apparam[sqdinx].bank.gain='..tostring(apparam[sqdinx].bank.gain))
	term.out('apparam[sqdinx].ptc.damp='..tostring(apparam[sqdinx].ptc.damp))
	term.out('apparam[sqdinx].ptc.gain='..tostring(apparam[sqdinx].ptc.gain))
	term.out('apparam[sqdinx].head.damp='..tostring(apparam[sqdinx].head.damp))
	term.out('apparam[sqdinx].head.gain='..tostring(apparam[sqdinx].head.gain))


	term.out('apparam[sqdinx].coord_rud.damp='..tostring(apparam[sqdinx].coord_rud.damp))
	term.out('apparam[sqdinx].coord_rud.gain='..tostring(apparam[sqdinx].coord_rud.gain))
	term.out('apparam[sqdinx].coord_elev.damp='..tostring(apparam[sqdinx].coord_elev.damp))
	term.out('apparam[sqdinx].coord_elev.gain='..tostring(apparam[sqdinx].coord_elev.gain))


	term.out('apparam[sqdinx].frmdz.damp='..tostring(apparam[sqdinx].frmdz.damp))
	term.out('apparam[sqdinx].frmdz.gain='..tostring(apparam[sqdinx].frmdz.gain))
	term.out('apparam[sqdinx].frmdx.damp='..tostring(apparam[sqdinx].frmdx.damp))
	term.out('apparam[sqdinx].frmdx.gain='..tostring(apparam[sqdinx].frmdx.gain))

	term.out('apparam[sqdinx].autoland_alt.damp='..tostring(apparam[sqdinx].autoland_alt.damp))
	term.out('apparam[sqdinx].autoland_alt.gain='..tostring(apparam[sqdinx].autoland_alt.gain))
	term.out('apparam[sqdinx].autoland_spd.damp='..tostring(apparam[sqdinx].autoland_spd.damp))
	term.out('apparam[sqdinx].autoland_spd.gain='..tostring(apparam[sqdinx].autoland_spd.gain))

	term.out('apparam[sqdinx].limits.takeoffmaxasc='..tostring(apparam[sqdinx].limits.takeoffmaxasc))
	term.out('apparam[sqdinx].limits.landingmaxdsc='..tostring(apparam[sqdinx].limits.landingmaxdsc))
	term.out('apparam[sqdinx].limits.maxasc='..tostring(apparam[sqdinx].limits.maxasc))
	term.out('apparam[sqdinx].limits.maxdsc='..tostring(apparam[sqdinx].limits.maxdsc))
	term.out('apparam[sqdinx].limits.banklimit='..tostring(apparam[sqdinx].limits.banklimit))

end

function h(val,sqdinx)

	if val<0 or val> 360 then term.out('Value out of limits. Enter a heading value from 0'..string.char(176)..' to 360'..string.char(176)..'.') return end

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx][0].tgthdg = val

	term.out('New heading set to '..string.format("%0.2f",val)..string.char(176)..'.')
end

function a(val,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx][0].tgtalt = val
	term.out('New altitude set to '..string.format("%0.2f",val)..'m.')
end

function s(val,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx][0].tgtspd = val
	term.out('New speed set to '..string.format("%0.2f",val)..'m/s.')
end

function f(vala,valb,sqdinx,wgmainx)

	if sqdinx ~= nil and wgmainx ~= nil then
		if wing[sqdinx] == nil then
			term.out('Invalid squadron number.')
			return
		elseif wing[sqdinx][wgmainx].vi == nil then
			term.out('Invalid wingman. Empty wingman slot.')
			return
		else
			wing[sqdinx][wgmainx].Formseq[1]= vala
			wing[sqdinx][wgmainx].Formseq[2]= valb
		end
	elseif sqdinx~=nil or wgmainx ~= nil then 
		term.out('Both squadron and wingman should be defined or none for focus plane.')
		return
	else
		sqdinx,wgmainx = findme(vessel.get_focusinterface())
		if sqdinx == nil then
			term.out('Squadron not found. Make sure the focus plane is part of a squadron.')
			return
		else
			wing[sqdinx][wgmainx].Formseq[1]= vala
			wing[sqdinx][wgmainx].Formseq[2]= valb
		end
	end
	term.out('New formation position for wingman #'..tostring(wgmainx)..' in squadron #'..tostring(sqdinx)..' set to {'..string.format("%0.0d",vala)..','..string.format("%0.0d",valb)..'}.')
end

function hr(val,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx].headrate = val
	term.out('New heading rate set to '..string.format("%0.2f",val)..string.char(176)..'/s.')
end

function d(val,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx].Forminterval = val
	term.out('New formation distance set to '..string.format("%0.2f",val)..'m.')
end

function an(val,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx].Formangle = val
	term.out('New formation angle set to '..string.format("%0.2f",val)..string.char(176)..'.')
end

function fm()
	
		local mywing,mypos = findme()
		if mywing ==nil then
			term.out('No squadron found for this plane.')
		else
			term.out('This plane is wingman #'..tostring(mypos)..' in the #'..tostring(mywing)..' squadron.')
		end
		

end

function sf(frmstr,sqdinx)
	
	if sqdinx ~= nil then
		if wing[sqdinx]== nil then term.out('Invalid squadron number. No such squadron.') return end
	else
		sqdinx = findme(vessel.get_focusinterface())
		if sqdinx == nil then term.out('Invalid squadron number. Focus plane is not assigned to any squadron.')  return end
	end
	wing[sqdinx][0].Formseq[1]= 0
	wing[sqdinx][0].Formseq[2] = 0 

	local frminx = 1
	
	--allowed formation name check
	if frmstr == 'line abreast' then
	elseif frmstr == 'line astern' then
	elseif frmstr == 'echelon left' then
	elseif frmstr == 'echelon right' then
	elseif frmstr == 'vic' then
	elseif frmstr == 'leaders benefit' then
	elseif frmstr == 'wedge' then
	initz = 1
	lengthx =2
	else
		term.out('Invalid formation name. Valid names are:')
		term.out('\'line abreast\'')
		term.out('\'line astern\'')
		term.out('\'echelon left\'')
		term.out('\'echelon right\'')
		term.out('\'vic\'')
		term.out('\'leaders benefit\'')
		term.out('\'wedge\'')
		return
	end

	while frminx < wing[sqdinx].count do
		if frmstr == 'line abreast' then
			wing[sqdinx][frminx].Formseq[1]= math.pow(-1,frminx) * math.ceil(frminx/2)
			wing[sqdinx][frminx].Formseq[2] = 0
		elseif frmstr == 'line astern' then
			wing[sqdinx][frminx].Formseq[1]=  0
			wing[sqdinx][frminx].Formseq[2] = -frminx
		elseif frmstr == 'echelon left' then
			wing[sqdinx][frminx].Formseq[1]= -frminx
			wing[sqdinx][frminx].Formseq[2] = -frminx
		elseif frmstr == 'echelon right' then
			wing[sqdinx][frminx].Formseq[1]= frminx
			wing[sqdinx][frminx].Formseq[2] = -frminx
		elseif frmstr == 'vic' then
			wing[sqdinx][frminx].Formseq[1]= math.pow(-1,frminx) * math.ceil(frminx/2)
			wing[sqdinx][frminx].Formseq[2] = -math.ceil(frminx/2)
		elseif frmstr == 'leaders benefit' then
			wing[sqdinx][frminx].Formseq[1]= math.pow(-1,(frminx-1)) * math.ceil((frminx-1)/2)
			wing[sqdinx][frminx].Formseq[2] = -1
		elseif frmstr == 'wedge' then
			local reven = false
			if lengthx/2 - math.floor(lengthx/2) == 0 then reven = true end
			if reven then
				wing[sqdinx][frminx].Formseq[1] = (2*math.ceil((frminx-initz-1)/2) +1) * -math.pow(-1,(frminx-initz))
			else
				wing[sqdinx][frminx].Formseq[1] = 2* math.ceil(((frminx-initz)/2))   *  math.pow(-1,(frminx-initz)) 
			end
			wing[sqdinx][frminx].Formseq[2] = 1-lengthx
			if frminx  == initz + lengthx-1  then
				initz=frminx + 1
				lengthx = lengthx+1
			end
		end
		frminx = frminx +1
	end

	term.out('New formation set to '..frmstr..'.')

end

function findme(vf)

	 if vf == nil then vf = vessel.get_focusinterface() end
	local sqdinx = 0
	while wing[sqdinx] ~= nil do
		local wgmainx = 0
		while wgmainx < wing[sqdinx].count do
			if wing[sqdinx][wgmainx].vi == vf then
				return sqdinx,wgmainx
			end
			wgmainx =wgmainx+1
		end
		sqdinx =sqdinx+1
	end

	return nil,nil

end

function dm(mode)

		if DEBUG.squadron ~= nil then 
			DEBUG.squadron = nil
			DEBUG.wingman = nil
			DEBUG.mode = ''
			oapi.dbg_out('')
		else
			if mode ~= 'surfaces' and mode~= 'rotors' and mode~= 'timestep'and mode~= 'autoland' and mode~= 'formz'and mode~= 'formx' then term.out('Currently accepted debug modes are:\n\'surfaces\',\n\'rotors\',\n\'autoland\',\n\'timestep\',\n\'formx\'\n\'formz\'.') return end
			DEBUG.squadron,DEBUG.wingman = findme()
			if mode == 'autoland' and  DEBUG.wingman ~= 0 then
				term.out('\'autoland\' debug mode only applies to the leader. Focus on a leader and retry.')
				DEBUG.squadron = nil
				DEBUG.wingman =nil
				return
			end
			if DEBUG.squadron == nil then term.out('This plane is not part of a squadron.') return end
			DEBUG.mode = mode
		end

end

function help()

	term.out('cs([leader_name]) - create squadron')
	term.out('ks(squadron_number) - kill squadron')
	term.out('cf([leader_name]) -  create flight')
	term.out('ps(squadron_number,[wingman_number],[frmsq]) - put in squadron)')
	term.out('xs([squadron_number,wingman_number]) - exclude from squadron)')
	term.out('ls([squadron_number]) - list squadron')
	term.out('lp([squadron_number]) - list autopilot parameters')

	term.out('h(val,[squadron_number]) - set heading')
	term.out('hr(val,[squadron_number]) - set heading change rate')
	term.out('a(val,[squadron_number]) - set altitude')
	term.out('s(val,[squadron_number]) - set speed')

	term.out('f(-left_+right,+fore_-aft,[squadron_number],[wingman_number]) - set formation position')
	term.out('d(val,[squadron_number]) - formation distance')
	term.out('an(val,[squadron_number]) - formation angle')

	term.out('sf(formation_name,[squadron_number]) - set formation by its name')



	term.out('efp(cruise_path_filename,[squadron_number],[initial_waypoint_number],[takeoff_land_mode]) - enter flight plan')
	term.out('etp([straight_leg_length],[squadron_number]) - enter traffic pattern')
	term.out('xfp([squadron_number]) - exit flight plan or traffic pattern')

	term.out('fm() - find me')

	term.out('dm([debug_mode]) - display debug information for FOCUS vessel.')


end


--*******************************************************************
--Autopilot Parameter Function
--*******************************************************************

function getparameters(clnm,sqdinx)

	clnm= string.lower(clnm)
	hprmfil = nil
	term.out('Looking for file in /Script/FAP/Parameter_Files/'..clnm..'.apm.')
	hprmfil = io.open('Script/FAP/Parameter_Files/'..clnm..'.apm',"r") -- From Orbiter root using division bars and without the first bar 
	if  hprmfil == nil then
		clnm = string.sub(clnm,1,#clnm-2)
		term.out('Could not open autopilot parameter file with full class name.')
		hprmfil = io.open('Script/FAP/Parameter_Files/'..clnm..'.apm',"r") -- From Orbiter root using division bars and without the first bar 
		if  hprmfil == nil then
			term.out('Could not open autopilot parameter file considering class name two character end as suffix.')
			return false
		else
			term.out('Found paramfile considering class name two character end as suffix.')
		end
	else
		term.out('Autopilot parameter file '..clnm..'.apm will be used for squadron '..tostring(sqdinx)..'.')
	end

	apparam[sqdinx].stdclassname = clnm

	apparam[sqdinx].category = nil
	apparam[sqdinx].alt = {damp=nil,gain=nil}
	apparam[sqdinx].spd ={damp=nil,gain=nil}
	apparam[sqdinx].bank ={damp=nil,gain=nil}
	apparam[sqdinx].ptc ={damp=nil,gain=nil}
	apparam[sqdinx].head ={damp=nil,gain=nil}
	apparam[sqdinx].coord_rud ={damp=nil,gain=nil}
	apparam[sqdinx].coord_elev ={damp=nil,gain=nil}
	apparam[sqdinx].frmdz ={damp=nil,gain=nil}
	apparam[sqdinx].frmdx ={damp=nil,gain=nil}
	apparam[sqdinx].autoland_alt ={damp=nil,gain=nil}
	apparam[sqdinx].autoland_spd ={damp=nil,gain=nil}
	apparam[sqdinx].limits = {takeoffmaxasc=nil,landingmaxdsc =nil, maxasc =nil, maxdsc =nil,banklimit=nil }


	readfromfile = hprmfil:read() --free first line
	repeat 
		parhintlen = string.find(readfromfile,' ',1)
		parhintstr = string.upper(string.sub(readfromfile,1,parhintlen-1))
		if parhintstr == 'CATEGORY' then
				apparam[sqdinx].category = hprmfil:read()
		elseif parhintstr == 'ALTITUDE' then
				apparam[sqdinx].alt.damp = tonumber(hprmfil:read())
				apparam[sqdinx].alt.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'SPEED' then
				apparam[sqdinx].spd.damp = tonumber(hprmfil:read())
				apparam[sqdinx].spd.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'BANK' then
				apparam[sqdinx].bank.damp = tonumber(hprmfil:read())
				apparam[sqdinx].bank.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'PITCH' then
				apparam[sqdinx].ptc.damp = tonumber(hprmfil:read())
				apparam[sqdinx].ptc.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'HEADING' then
				apparam[sqdinx].head.damp = tonumber(hprmfil:read())
				apparam[sqdinx].head.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'RUDDER_AUTOCOORD' then
				apparam[sqdinx].coord_rud.damp = tonumber(hprmfil:read())
				apparam[sqdinx].coord_rud.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'ELEVATOR_AUTOCOORD' then
				apparam[sqdinx].coord_elev.damp = tonumber(hprmfil:read())
				apparam[sqdinx].coord_elev.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'FORMATION_Z' then
				apparam[sqdinx].frmdz.damp = tonumber(hprmfil:read())
				apparam[sqdinx].frmdz.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'FORMATION_X' then
				apparam[sqdinx].frmdx.damp = tonumber(hprmfil:read())
				apparam[sqdinx].frmdx.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'AUTOLAND_ALTITUDE' then
			apparam[sqdinx].autoland_alt.damp = tonumber(hprmfil:read())
			apparam[sqdinx].autoland_alt.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'AUTOLAND_SPEED' then
			apparam[sqdinx].autoland_spd.damp = tonumber(hprmfil:read())
			apparam[sqdinx].autoland_spd.gain = tonumber(hprmfil:read())
		elseif parhintstr == 'MAXIMUM_SLOPE' then
			apparam[sqdinx].limits.takeoffmaxasc = tonumber(hprmfil:read())
			apparam[sqdinx].limits.landingmaxdsc = tonumber(hprmfil:read())
			apparam[sqdinx].limits.maxasc = tonumber(hprmfil:read())
			apparam[sqdinx].limits.maxdsc = tonumber(hprmfil:read())
		elseif parhintstr == 'MAXIMUM_BANK' then
			apparam[sqdinx].limits.banklimit = tonumber(hprmfil:read())
		end
		readfromfile = hprmfil:read()
	until readfromfile == nil

	hprmfil:close()

	term.out('Autopilot parameters loaded.')

	return true
end


function old_getparameters(clnm,sqdinx)


	clnm= string.lower(clnm)
	hprmfil = nil
	term.out('Looking for file in /Script/FAP/Parameter_Files/'..clnm..'.apm.')
	hprmfil = io.open('Script/FAP/Parameter_Files/'..clnm..'.apm',"r") -- From Orbiter root using division bars and without the first bar 
	if  hprmfil == nil then
		clnm = string.sub(clnm,1,#clnm-2)
		term.out('Could not open autopilot parameter file with full class name.')
		hprmfil = io.open('Script/FAP/Parameter_Files/'..clnm..'.apm',"r") -- From Orbiter root using division bars and without the first bar 
		if  hprmfil == nil then
			term.out('Could not open autopilot parameter file considering class name two character end as suffix.')
			return false
		else
			term.out('Found paramfile considering class name two character end as suffix.')
		end
	else
		term.out('Autopilot parameter file '..clnm..'.apm will be used for squadron '..tostring(sqdinx)..'.')
	end

	apparam[sqdinx].stdclassname = clnm

	hprmfil:read()
	hprmfil:read()
	apparam[sqdinx].alt ={}
	apparam[sqdinx].alt.damp = tonumber(hprmfil:read())
	apparam[sqdinx].alt.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].spd ={}
	apparam[sqdinx].spd.damp = tonumber(hprmfil:read())
	apparam[sqdinx].spd.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].bank ={}
	apparam[sqdinx].bank.damp = tonumber(hprmfil:read())
	apparam[sqdinx].bank.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].head ={}
	apparam[sqdinx].head.damp = tonumber(hprmfil:read())
	apparam[sqdinx].head.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].coord_rud ={}
	apparam[sqdinx].coord_rud.damp = tonumber(hprmfil:read())
	apparam[sqdinx].coord_rud.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].coord_elev ={}
	apparam[sqdinx].coord_elev.damp = tonumber(hprmfil:read())
	apparam[sqdinx].coord_elev.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].frmdz ={}
	apparam[sqdinx].frmdz.damp = tonumber(hprmfil:read())
	apparam[sqdinx].frmdz.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].frmdx ={}
	apparam[sqdinx].frmdx.damp = tonumber(hprmfil:read())
	apparam[sqdinx].frmdx.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].autoland_alt ={}
	apparam[sqdinx].autoland_alt.damp = tonumber(hprmfil:read())
	apparam[sqdinx].autoland_alt.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].autoland_spd ={}
	apparam[sqdinx].autoland_spd.damp = tonumber(hprmfil:read())
	apparam[sqdinx].autoland_spd.gain = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].limits ={}
	apparam[sqdinx].limits.takeoffmaxasc = tonumber(hprmfil:read())
	apparam[sqdinx].limits.landingmaxdsc = tonumber(hprmfil:read())
	apparam[sqdinx].limits.maxasc = tonumber(hprmfil:read())
	apparam[sqdinx].limits.maxdsc = tonumber(hprmfil:read())
	hprmfil:read()
	apparam[sqdinx].limits.banklimit = tonumber(hprmfil:read())
	hprmfil:close()

	term.out('Autopilot parameters loaded.')

	return true

end

--*******************************************************************
--Coordinate Transfer Functions
--*******************************************************************

function sunglb2plncart4orient(hplanet,glborientvctr)

	
	
	--OBS: This routine is intended for ORIENTATION vectors that are defined globally
	--and need to be converted to a planet cartesian frame
	--Do NOT use it for position vectors!!!

	--convert this ORIENTATION to equ despite its not a position but a ORIENTATION
	local equdistvectotgt = oapi.global_to_equ(hplanet,glborientvctr)
	--then get the very sun with reference to the same planet
	local vsunequ = oapi.global_to_equ(hplanet,{x=0,y=0,z=0})
	--convert both to equatorial cartesian 
	local plncartdistvec = plnequ2plncart(equdistvectotgt)
	local vsunplncart = plnequ2plncart(vsunequ)

	--subtract to get orientation in planet cartesian coords
	return vec.sub(plncartdistvec,vsunplncart)

end

function plnequ2plncart(equ)

--====================================================================================================
--Convertion of camera coord from Planet Equ Geo Coord to Planet Equ Cart Coordinates
--====================================================================================================

 
local ca = math.cos(equ.lat)
local sa = math.sin(equ.lat)
local so = math.sin(equ.lng)
local co = math.cos(equ.lng)

	plncart = {
		x = equ.rad*ca*so,
		y = equ.rad*ca*co,
		z = equ.rad*sa
		}


return plncart


end

function plncart2LHLV(vdir,hvessel) --Certified!!
--======================================================================================================
--Converting from Planet Cartesian Coordinates to Local Horizon Coord at vessel position
--VECTOR TO BE TRANSFORMED is given in planet cartesian coordinates (x,y,z)
--======================================================================================================

	vvessel = oapi.get_equpos(hvessel)

	cb=math.cos(vvessel.lng)
	sb=math.sin(vvessel.lng)
	cp=math.cos(vvessel.lat)
	sp=math.sin(vvessel.lat)

	--Aca below means....
	--How the A (new or LHLV) projection is affected by a versor the (old) cartesian  basis considering LAT,LON
	--We may consider LON as bank and LAT as pitch for a plane north (LHLVZ to planetZ) oriented


	Xcx = cb --OK
	Ycx = sb*cp--OK
	Zcx = -sp*sb--OK

	Xcy = -sb--OK
	Ycy = cp*cb--OK
	Zcy = -sp*cb--OK

	Xcz = 0--OK
	Ycz = sp--OK
	Zcz = cp--OK


	vLHLV = {
		x=vdir.x * Xcx + vdir.y *Xcy + vdir.z *Xcz,
		y=vdir.x * Ycx + vdir.y *Ycy + vdir.z *Ycz,
		z=vdir.x * Zcx + vdir.y *Zcy + vdir.z *Zcz
		}

	return vLHLV
end

function LHLV2vssl(LHLVvector,vship)

	--This function converts a LHLV based vector (normally the vessel to target vector)
	-- to a vessel frame based vector

	local pitch,yaw,bank,Xhx,Xhy,Xhz,Yhx,Yhy,Yhz,Zhx,Zhy,Zhz
	local sy,cy,sp,cp,sb,cb



	pitch = vship:get_pitch()
	--90 degrees minus the angle between the vessel's positive z-axis and the normal to the local horizon.(* -1 ?)

	bank = vship:get_bank()
	--the angle between the vessel's positive y axis (up direction) and the projection of the normal of the local --horizon into the x-y plane.

	yaw = vship:get_yaw()
	--the angle between the the projection of the vessel's positive z axis (forward direction) into the horizon --plane, and the local horizon "north" direction.

--Pitch is positive Up (climb)
--Bank is positive when plane banks to the left (cCW from the pilot POV)
--Yaw is positive to starboard (=compass)


--Conversion below follows this convention:

-- LH base is the vel = vrfd:get_horizonairspeedvector() orientation which is
-- x = longitudinal component, y = vertical component, z = latitudinal component.

--                  /\ Z==North
--                  |
--                  |------> X ==East
--                 (.) Y Up

--The orientation is left handed but this is the way it is 
--As the vessel orientation is also left handed...
--a vessel at 0 LAT 0 LON and N oriented has its own base  aligned to planet base

--                  /\ Z=Bow
--                  |
--                  |------> X ==Stb
--                 (.) Y Up

-- ' Aha ' below means how the projection from a versor (on the LHLV world base axis) over A ( a vessel base axis ) is affected by turning of the vessel .
--It may be read: "The contribution of 'a' versor to the 'A' axis"


	cy = math.cos(yaw)
	sy = math.sin(yaw)
	cb = math.cos(bank)
	sb = math.sin(bank)
	cp = math.cos(pitch)
	sp = math.sin(pitch)


	Xhx = cy*cb - sy*sp*sb --OK
	Yhx = -sy*sp*cb - cy*sb*cp --OK
	Zhx = sy*cp --OK

	Xhy = sb*cp --OK
	Yhy = cp*cb --OK
	Zhy = sp --OK

	Xhz = -sy*cb - sp*sb*cy --OK
	Yhz = -sp*cb*cy + sy*sb*cp --OK
	Zhz = cp*cy --OK


	local vsslbased = { 
		x=LHLVvector.x * Xhx + LHLVvector.y *Xhy + LHLVvector.z *Xhz,
		y=LHLVvector.x * Yhx + LHLVvector.y *Yhy + LHLVvector.z *Yhz,
		z=LHLVvector.x * Zhx + LHLVvector.y *Zhy + LHLVvector.z *Zhz
		}



--[[

--**************DEBDEBDEBDEB*************************
strdbg =' LHLVbased.x:'..string.format('%0.3f',LHLVvector.x)..' y:'..string.format('%0.3f',LHLVvector.y)..' z:'..string.format('%0.3f',LHLVvector.z)
strdbg = strdbg.. ' cambased x:'..string.format('%0.3f',cambased.x)..' y:'..string.format('%0.3f',cambased.y)..' z:'..string.format('%0.3f',cambased.z)
oapi.dbg_out(strdbg)
--**************DEBDEBDEBDEB*************************
--]]

return vsslbased

end

function vssl2LHLV(vship,vcttoxfrm)

	local pitch,yaw,bank,Xhx,Xhy,Xhz,Yhx,Yhy,Yhz,Zhx,Zhy,Zhz,Xcx,Xcy,Xcz,Ycx,Ycy,Ycz,Zcx,Zcy,Zcz
	local sy,cy,sp,cp,sb,cb,ca,sa,co,so
--====================================================================================================
--Convertion from Vessel coord to Local Horizon Coord
--====================================================================================================
	pitch = vship:get_pitch()
	--90 degrees minus the angle between the vessel's positive z-axis and the normal to the local horizon.(* -1 ?)

	bank = vship:get_bank()
	--the angle between the vessel's positive y axis (up direction) and the projection of the normal of the local --horizon into the x-y plane.

	yaw = vship:get_yaw()
	--the angle between the the projection of the vessel's positive z axis (forward direction) into the horizon --plane, and the local horizon "north" direction.

--Pitch is positive Up (climb)
--Bank is positive when plane banks to the left (cCW from the pilot POV)
--Yaw is positive to starboard (=compass)


--Conversion below follows this convention:

-- LH base is the vel = vrfd:get_horizonairspeedvector() orientation which is
-- x = longitudinal component, y = vertical component, z = latitudinal component.

--                  /\ Z==North
--                  |
--                  |------> X ==East
--                 (.) Y Up

--The orientation is left handed but this is the way it is 
--As the vessel orientation is also left handed...
--a vessel at 0 LAT 0 LON and N oriented has its own base  aligned to planet base

--                  /\ Z=Bow
--                  |
--                  |------> X ==Stb
--                 (.) Y Up

-- ' Aha ' below means how the projection over A ( the world (new) base axis ) is affected by turning of a (the vessel (old) base axis)
--It may be read: "The contribution of 'a' versor to the 'A' axis"

	cy = math.cos(yaw)
	sy = math.sin(yaw)
	cb = math.cos(bank)
	sb = math.sin(bank)
	cp = math.cos(pitch)
	sp = math.sin(pitch)


	Xhx = cy*cb - sy*sp*sb--OK
	Yhx = sb*cp --OK
	Zhx = -sy*cb - sp*sb*cy

	Xhy = -sb*cy*cp - sy*sp*cb--OK   
	Yhy = cp*cb--OK
	Zhy = -sp*cy*cb + sb*sy*cp --OK 

	Xhz = sy*cp--OK
	Yhz = sp--OK
	Zhz = cp*cy --OK


	 LHLVvctr = {
		x=vcttoxfrm.x * Xhx + vcttoxfrm.y *Xhy + vcttoxfrm.z *Xhz,
		y=vcttoxfrm.x * Yhx + vcttoxfrm.y *Yhy + vcttoxfrm.z *Yhz,
		z=vcttoxfrm.x * Zhx + vcttoxfrm.y *Zhy + vcttoxfrm.z *Zhz
		}
--[[
--****************DEBDEBDEB*********************
local strdbg = 'LHLVvctr x:'..string.format('%0.3f',LHLVvctr.x)..' y:'..string.format('%0.3f',LHLVvctr.y)..' z:'..string.format('%0.3f',LHLVvctr.z)
oapi.dbg_out(strdbg)
--****************DEBDEBDEB*********************
--]]
		return LHLVvctr
end

--*******************************************************************
--Geographic Equatorial Waypoint Cruise File Handling Functions
--*******************************************************************

function distandcoursebetweentwopoints( original_point, terminal_point )
	--inherited from the lunar railroad project but modified

	if original_point == terminal_point then return 0,0 end

	local tcrs_org2trm

	local dist_org2trm = oapi.orthodome (original_point, terminal_point)
		if math.abs(terminal_point.lat - original_point.lat) < 1e-6 then
		tcrs_org2trm = math.pi/2 * (terminal_point.lng -original_point.lng)/math.abs(terminal_point.lng -original_point.lng)
		elseif math.abs(terminal_point.lng - original_point.lng) < 1e-6 then
		tcrs_org2trm =   math.pi/2*( (terminal_point.lat - original_point.lat)/math.abs(terminal_point.lat - original_point.lat) - 1 )

	else
		tcrs_org2trm = math.acos((math.sin(terminal_point.lat) - math.sin(original_point.lat) *  math.cos(dist_org2trm))/(math.sin(dist_org2trm)*math.cos(original_point.lat)))
		if math.sin(terminal_point.lng - original_point.lng) < 0 then
			tcrs_org2trm = 2 * math.pi - tcrs_org2trm
		end
	end

	if tcrs_org2trm > math.pi then tcrs_org2trm = tcrs_org2trm - 2* math.pi end

	return dist_org2trm,tcrs_org2trm

end

function get_crswpnts(sqdinx,crswpflnme,presentpos)


	local planetradius = oapi.get_size(hplanet)
	local lineread = ''
	local wpidx = 0
	local sdx1,sdx2,sdx3


	myfile = io.open('config/mfd/designator/cruise_paths/'..crswpflnme..'.txt',"r")
	if myfile ~= nil then

		while lineread ~= 'BEGIN_WAYPOINTLIST' do
			lineread = myfile:read()

		end
		lineread = myfile:read()
		wing[sqdinx].crswp = {}

		while lineread ~= 'END_WAYPOINTLIST' do
			wing[sqdinx].crswp[wpidx] ={}
			local sdx1 = string.find (lineread,' ',1)
			local sdx2 = string.find (lineread,' ',sdx1 + 1)
			local sdx3 = string.find (lineread,' ',sdx2 + 1)
			if sdx3 == nil then wing[sqdinx].crswp[wpidx].altmode = 'G' else wing[sqdinx].crswp[wpidx].altmode = string.sub(lineread,sdx3+1) end
			wing[sqdinx].crswp[wpidx].lat = math.rad(string.sub(lineread,1,sdx1-1))
			wing[sqdinx].crswp[wpidx].lng = math.rad(string.sub(lineread,sdx1+1,sdx2-1))
			if wpidx > 0 then
				wing[sqdinx].crswp[wpidx].dst,wing[sqdinx].crswp[wpidx].hdg  = distandcoursebetweentwopoints({lat = wing[sqdinx].crswp[wpidx-1].lat, lng= wing[sqdinx].crswp[wpidx-1].lng}, {lat = wing[sqdinx].crswp[wpidx].lat, lng= wing[sqdinx].crswp[wpidx].lng})
			else
				wing[sqdinx].crswp[wpidx].dst, wing[sqdinx].crswp[wpidx].hdg = distandcoursebetweentwopoints ({lat = presentpos.lat, lng= presentpos.lng}, {lat = wing[sqdinx].crswp[wpidx].lat, lng= wing[sqdinx].crswp[wpidx].lng})
			end
			wing[sqdinx].crswp[wpidx].dst =wing[sqdinx].crswp[wpidx].dst * planetradius
			if sdx3 == nil then wing[sqdinx].crswp[wpidx].alt = string.sub(lineread,sdx2+1) else wing[sqdinx].crswp[wpidx].alt = string.sub(lineread,sdx2+1,sdx3-1) end
			lineread = myfile:read()
			wpidx =wpidx +1
		end
		myfile:close()

	else
		term.out('File not Found')
		return -1
	end

	return wpidx

end

function equfromroute(gvncoords,heading,distance)

--Calculates destination equatorial coordinates from an initial point , a heading and a given distance

	local calcoords = {lat= 0,lng =0}

	local raddst = distance/oapi.get_size(hplanet)


	calcoords.lat = math.asin( math.sin(gvncoords.lat) * math.cos(raddst) + math.cos(gvncoords.lat) * math.sin(raddst) *  math.cos(heading))
	calcoords.lng = gvncoords.lng + math.atan2(math.sin(heading) * math.sin(raddst) * math.cos(gvncoords.lat), math.cos(raddst) - math.sin(gvncoords.lat) * math.sin(calcoords.lat))


	return calcoords
end


--******************************************************
-- Autopilot Section
--Adapted from Deltaglider Orbiter Original /Script/DG/aap.lua
--******************************************************

function DisableAllInternalAPs(sqdinx,wgmainx)

	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.HOLDALT,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.HLEVEL,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.KILLROT,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.PROGRADE,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.RETROGRADE,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.NORMAL,false)
	wing[sqdinx][wgmainx].vi:set_navmode(NAVMODE.ANTINORMAL,false)

end

function GND_altitude (sqdinx,wgmainx)
    alt = wing[sqdinx][wgmainx].vi:get_altitude(ALTMODE.GROUND)
    return alt
end

function BAR_altitude (sqdinx,wgmainx)

    return wing[sqdinx][wgmainx].vi:get_altitude(ALTMODE.MEANRAD)
	
end

function airspeed (sqdinx,wgmainx)
    local aspdvec = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.LOCAL)
	if aspdvec.z == 0 then sgnaspd = 1 else  sgnaspd = aspdvec.z/math.abs(aspdvec.z) end

	return sgnaspd* vec.length(aspdvec)

end

function slope (sqdinx,wgmainx)
    as = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.HORIZON)
    xz = math.sqrt (as.x^2 + as.z^2)
    sl = math.atan2 (as.y, xz)
    return sl
end

function yaw(sqdinx,wgmainx)

	local yw = wing[sqdinx][wgmainx].vi:get_yaw() 
	return yw
	
end

function get_pitchandpitchrateandAOA(sqdinx,wgmainx,simdt)

--should be called ONCE perstep because it updates pitch0

	local LHLVLeadspeed =  wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.HORIZON)
	local pitchvessel = wing[sqdinx][wgmainx].vi:get_pitch()
	local dpitchrate = (pitchvessel - wing[sqdinx][wgmainx].pitch0)/simdt
	--wing[sqdinx][wgmainx].pitch0 = pitchvessel
	local pitchvel =  math.atan2( LHLVLeadspeed.y,math.sqrt(LHLVLeadspeed.x^2+LHLVLeadspeed.z^2))
	local isAOA = pitchvessel - pitchvel
	if isAOA > math.pi then isAOA = isAOA - 2*math.pi end --?
	if isAOA < -math.pi then isAOA = isAOA + 2*math.pi end --?
	return pitchvessel,dpitchrate,isAOA

end

function BAR_alt_ap (alt,sqdinx,wgmainx)

	local dt = oapi.get_simstep()
	pralt = BAR_altitude(sqdinx,wgmainx)
	dalt = alt-pralt
	wing[sqdinx][wgmainx].tgtslope = RAD * hardcoded_dalt_to_slope * dalt 
	gralt =wing[sqdinx][wgmainx].vi:get_altitude(ALTMODE.GROUND)
		if wing[sqdinx][wgmainx].tgtslope > apparam[sqdinx].limits.maxasc*RAD then
			wing[sqdinx][wgmainx].tgtslope = apparam[sqdinx].limits.maxasc*RAD
		elseif wing[sqdinx][wgmainx].tgtslope < apparam[sqdinx].limits.maxdsc*RAD then
				wing[sqdinx][wgmainx].tgtslope = apparam[sqdinx].limits.maxdsc*RAD
		end
	return wing[sqdinx][wgmainx].tgtslope
end

function BAR_alt_Vap (alt,sqdinx,wgmainx)

	local dt = oapi.get_simstep()
	pralt = BAR_altitude(sqdinx,wgmainx)
	dalt = alt-pralt

   vac = (pralt-wing[sqdinx][wgmainx].alt0)/dt
   wing[sqdinx][wgmainx].alt0 = pralt
   dcolec = ( -vac + dalt*1/apparam[sqdinx].alt.damp)* apparam[sqdinx].alt.gain * dt
   colec = wing[sqdinx][wgmainx].vi:get_thrustergrouplevel (THGROUP.HOVER)
   if colec+dcolec <= 1e-4 then colec = 1e-4 dcolec = 0 end  --sound purposes
   wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.HOVER, colec+dcolec)

end

function slope_ap(slp,sqdinx,wgmainx )
	local dt = oapi.get_simstep()
	dslope = slp - slope(sqdinx,wgmainx)
	if wing[sqdinx][wgmainx].dslope0 == 0 then
		dslope_rate = 0
	else
		dslope_rate = (dslope-wing[sqdinx][wgmainx].dslope0)/dt
	end
	wing[sqdinx][wgmainx].dslope0= dslope
	delev = (dslope_rate +1/apparam[sqdinx].alt.damp * dslope)*(dt* apparam[sqdinx].alt.gain)
	wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.ELEVATOR)
	wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].elevcomm + delev 
	if wing[sqdinx][wgmainx].elevcomm > 1 then wing[sqdinx][wgmainx].elevcomm = 1 elseif wing[sqdinx][wgmainx].elevcomm < -1 then wing[sqdinx][wgmainx].elevcomm = -1 end
	wing[sqdinx][wgmainx].vi:set_adclevel(AIRCTRL.ELEVATOR,wing[sqdinx][wgmainx].elevcomm)

end

function spd_ap (spd,sqdinx,wgmainx)
    
    local acc, dpsd

        local dt = oapi.get_simstep()
        prspd = airspeed(sqdinx,wgmainx)

		if spd<0 then --landing braking
			wing[sqdinx][wgmainx].vi:set_thrustergrouplevel(THGROUP.MAIN,0)
			if prspd > 0 then
				wing[sqdinx][wgmainx].vi:set_thrustergrouplevel(THGROUP.RETRO,1)
			else
				wing[sqdinx][wgmainx].vi:set_thrustergrouplevel(THGROUP.RETRO,0)
			end 
			return
		end

        acc = (prspd-wing[sqdinx][wgmainx].spd0)/dt
        wing[sqdinx][wgmainx].spd0 = prspd --?????
        dspd = spd-prspd
        dthrott = (- acc +dspd*1/apparam[sqdinx].spd.damp)* apparam[sqdinx].spd.gain * dt
        thrott = wing[sqdinx][wgmainx].vi:get_thrustergrouplevel (THGROUP.MAIN)
        if thrott+dthrott <= 1e-4 then thrott = 1e-4 dthrott = 0 end  --sound purposes
        wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.MAIN, thrott+dthrott)

end

function bank_ap (bnk,sqdinx,wgmainx)

    local dt = oapi.get_simstep()
    prbnk = wing[sqdinx][wgmainx].vi:get_bank()
    dbnk = prbnk-wing[sqdinx][wgmainx].bnk0
    if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
    rate = dbnk/dt
    wing[sqdinx][wgmainx].bnk0 = prbnk
    dbnk = bnk * RAD - prbnk
    if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
    dail = (rate + dbnk* (-1/apparam[sqdinx].bank.damp))  * (dt*apparam[sqdinx].bank.gain) --<<the damping term should really depend on atmospheric density  ORG: dail = (rate + dbnk* (-.2))  * (dt*.65)
    ail = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.AILERON)
    ail = ail+dail
    if ail > 1 then ail = 1 elseif ail < -1 then ail = -1 end
    wing[sqdinx][wgmainx].vi:set_adclevel(AIRCTRL.AILERON,ail)

end

function speed_Vap (spd,sqdinx,wgmainx)
 
	
    local vairvel = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.LOCAL)
	local hxxpitch = wing[sqdinx][wgmainx].vi:get_pitch()
	local airvelfwd = math.sqrt(vairvel.z^2+vairvel.y^2)* vairvel.z/math.abs(vairvel.z)* math.cos (hxxpitch)

    local dt = oapi.get_simstep()

	prspd = airvelfwd
    dspd = prspd - spd 
    rate = (prspd-wing[sqdinx][wgmainx].spd0)/dt
    wing[sqdinx][wgmainx].spd0 = prspd
    dpitch = ( rate + 1/apparam[sqdinx].spd.damp* dspd)*dt* apparam[sqdinx].spd.gain 
    wing[sqdinx][wgmainx].tgtptc = hxxpitch + dpitch
	
    if wing[sqdinx][wgmainx].tgtptc> apparam[sqdinx].limits.maxasc*RAD then wing[sqdinx][wgmainx].tgtptc = apparam[sqdinx].limits.maxasc*RAD elseif wing[sqdinx][wgmainx].tgtptc < apparam[sqdinx].limits.maxdsc*RAD then wing[sqdinx][wgmainx].tgtptc = apparam[sqdinx].limits.landingmaxdsc*RAD end
	wing[sqdinx][wgmainx].tgtptc = wing[sqdinx][wgmainx].tgtptc * DEG
	--dbgstring = 'prspd:'..tostring(prspd)..' dspd:'..tostring(dspd)..' rate:'..tostring(rate)..' dpitch'..tostring(dpitch)..' tgtptc:'..tostring(wing[sqdinx][wgmainx].tgtptc)
	--oapi.dbg_out(dbgstring)
	return wing[sqdinx][wgmainx].tgtptc
	
end

function pitch_Vap (ptc,sqdinx,wgmainx)



	local dt = oapi.get_simstep()
	prptc = wing[sqdinx][wgmainx].vi:get_pitch()
	dptc = prptc - ptc * RAD 

	if dptc < -PI then dptc = dptc+2*PI elseif dptc > PI then dptc = dptc-2*PI end -- phase unwrap
	rate = (prptc-wing[sqdinx][wgmainx].ptc0)/dt
	wing[sqdinx][wgmainx].ptc0 = prptc

	dciclic = (-rate - dptc* (1/apparam[sqdinx].ptc.damp))* dt* apparam[sqdinx].ptc.gain
	
	if dciclic > 1 then dciclic =1 end
	if dciclic < -1 then dciclic =-1 end

	wing[sqdinx][wgmainx].ciclicptc = wing[sqdinx][wgmainx].ciclicptc + dciclic
	if wing[sqdinx][wgmainx].ciclicptc>1 then wing[sqdinx][wgmainx].ciclicptc = 1 elseif wing[sqdinx][wgmainx].ciclicptc <-1 then wing[sqdinx][wgmainx].ciclicptc = -1 end

	if wing[sqdinx][wgmainx].ciclicptc > 0  then
		wing[sqdinx][wgmainx].vi:inc_thrustergrouplevel (THGROUP.ATT_PITCHUP,.5 * wing[sqdinx][wgmainx].ciclicptc)
	else
		wing[sqdinx][wgmainx].vi:inc_thrustergrouplevel (THGROUP.ATT_PITCHDOWN, -.5 * wing[sqdinx][wgmainx].ciclicptc)
	end
	
end

function bank_Vap (bnk,sqdinx,wgmainx)
--CCW is positive

	local dt = oapi.get_simstep()
	prbnk = wing[sqdinx][wgmainx].vi:get_bank()
	dbnk = prbnk - bnk * RAD 
	
	if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
	rate = (prbnk-wing[sqdinx][wgmainx].bnk0)/dt
	wing[sqdinx][wgmainx].bnk0 = prbnk
	
	if dbnk < -PI then dbnk = dbnk+2*PI elseif dbnk > PI then dbnk = dbnk-2*PI end -- phase unwrap
	dciclic = (-rate - dbnk* (1/apparam[sqdinx].bank.damp))* dt* apparam[sqdinx].bank.gain

	if dciclic > 1 then dciclic =1 end
	if dciclic < -1 then dciclic =-1 end

	wing[sqdinx][wgmainx].ciclicbnk = wing[sqdinx][wgmainx].ciclicbnk + dciclic
	if wing[sqdinx][wgmainx].ciclicbnk>1 then wing[sqdinx][wgmainx].ciclicbnk = 1 elseif wing[sqdinx][wgmainx].ciclicbnk <-1 then wing[sqdinx][wgmainx].ciclicbnk = -1 end
	
	if wing[sqdinx][wgmainx].ciclicbnk> 0 then
		wing[sqdinx][wgmainx].vi:inc_thrustergrouplevel (THGROUP.ATT_BANKLEFT,.5*wing[sqdinx][wgmainx].ciclicbnk)
	else
		wing[sqdinx][wgmainx].vi:inc_thrustergrouplevel (THGROUP.ATT_BANKRIGHT,-.5*wing[sqdinx][wgmainx].ciclicbnk)
	end

end

function yaw_ap (yw,sqdinx,wgmainx) -- Ground steeering only

    local dt = oapi.get_simstep()
    pryw = wing[sqdinx][wgmainx].vi:get_yaw()
    dyw = pryw-wing[sqdinx][wgmainx].yaw0
    if dyw < -PI then dyw = dyw+2*PI elseif dyw > PI then dyw = dyw-2*PI end -- phase unwrap
    rate = dyw/dt
    wing[sqdinx][wgmainx].yaw0 = pryw
    dyw = yw * RAD - pryw
    if dyw < -PI then dyw = dyw+2*PI elseif dyw > PI then dyw = dyw-2*PI end -- phase unwrap
    drud = (rate + dyw* (-1/apparam[sqdinx].coord_rud.damp))  * (dt*apparam[sqdinx].coord_rud.gain) 
    rud = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.RUDDER)
    rud = rud+drud
    if rud > 1 then rud = 1 elseif rud < -1 then rud = -1 end
    wing[sqdinx][wgmainx].vi:set_adclevel(AIRCTRL.RUDDER,rud)


end

function heading_ap (hdg,sqdinx,wgmainx)
 
	
    local vairvel = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.HORIZON)
	local airvelhdg = math.atan2(vairvel.x,vairvel.z)
	if airvelhdg < 0 then airvelhdg = 2* PI + airvelhdg end

    local dt = oapi.get_simstep()

	prhdg = airvelhdg
    dhdg = prhdg - wing[sqdinx][wgmainx].hdg0
    if dhdg < -PI then dhdg = dhdg+2*PI elseif dhdg > PI then dhdg = dhdg-2*PI end -- phase unwrap
    rate = dhdg/dt
    wing[sqdinx][wgmainx].hdg0 = prhdg
    dhdg = hdg * RAD - prhdg
    if dhdg < -PI then dhdg = dhdg+2*PI elseif dhdg > PI then dhdg = dhdg-2*PI end -- phase unwrap
    dbank = (rate - 1/apparam[sqdinx].head.damp* dhdg)*dt* apparam[sqdinx].head.gain --!   (-dhdg*1 + rate*40)*dt*100 --!  (rate - .025* dhdg)*dt* 4000 --! 
    wing[sqdinx][wgmainx].tgtbnk = wing[sqdinx][wgmainx].vi:get_bank() + dbank
    if wing[sqdinx][wgmainx].tgtbnk > apparam[sqdinx].limits.banklimit*RAD then wing[sqdinx][wgmainx].tgtbnk = apparam[sqdinx].limits.banklimit*RAD elseif wing[sqdinx][wgmainx].tgtbnk < -apparam[sqdinx].limits.banklimit*RAD then wing[sqdinx][wgmainx].tgtbnk = -apparam[sqdinx].limits.banklimit*RAD end
    wing[sqdinx][wgmainx].tgtbnk = wing[sqdinx][wgmainx].tgtbnk * DEG

	return wing[sqdinx][wgmainx].tgtbnk
end

function autocoord_ap (sqdinx,wgmainx)
    
	--Should be the LAST ap to deal with AIRCTRL.ELEVATOR because it adds over elev from previous alt ap


    local dt = oapi.get_simstep()
    vslyaw = wing[sqdinx][wgmainx].vi:get_yaw()
	if vslyaw < -PI then vslyaw = vslyaw+2*PI elseif vslyaw > PI then vslyaw = vslyaw-2*PI end -- phase unwrap

	LHLVasv= wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.HORIZON)

	spdyaw = math.atan2(LHLVasv.x,LHLVasv.z)
	if spdyaw < -PI then spdyaw = spdyaw+2*PI elseif spdyaw > PI then spdyaw = spdyaw-2*PI end -- phase unwrap

    dyaw = (spdyaw - vslyaw)

    if dyaw < -PI then dyaw = dyaw+2*PI elseif dyaw > PI then dyaw = dyaw-2*PI end -- phase unwrap

    dyaw_rate = (dyaw-wing[sqdinx][wgmainx].dyaw0)/dt
    wing[sqdinx][wgmainx].dyaw0 = dyaw

	drud = (dyaw_rate + 1/apparam[sqdinx].coord_rud.damp * dyaw ) * (dt * apparam[sqdinx].coord_rud.gain) * math.abs(math.cos(wing[sqdinx][wgmainx].vi:get_bank())) -- (   (a = 0 ) * 1/2qw * D2 + D1 + (b)* w/2q * D0    ) * G  (b=.2 G=.375)
	rud = wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.RUDDER)
	rud = rud+drud
	if rud > 1 then rud = 1 elseif rud < -1 then rud = -1 end
	wing[sqdinx][wgmainx].vi:set_adclevel(AIRCTRL.RUDDER,rud)

	delev = -(dyaw_rate + 1/apparam[sqdinx].coord_elev.damp * dyaw ) * (dt * apparam[sqdinx].coord_elev.gain) * -math.sin(wing[sqdinx][wgmainx].vi:get_bank()) -- (   (a = 0 ) * 1/2qw * D2 + D1 + (b)* w/2q * D0    ) * G  (b=.2 G=.2)
	wing[sqdinx][wgmainx].elevcomm = wing[sqdinx][wgmainx].elevcomm+delev
	if wing[sqdinx][wgmainx].elevcomm > 1 then wing[sqdinx][wgmainx].elevcomm = 1 elseif wing[sqdinx][wgmainx].elevcomm < -1 then wing[sqdinx][wgmainx].elevcomm = -1 end
	wing[sqdinx][wgmainx].vi:set_adclevel(AIRCTRL.ELEVATOR,wing[sqdinx][wgmainx].elevcomm)

	--oapi.dbg_out('vy:'..string.format("%0.5f",vslyaw*180/math.pi)..'sy:'..string.format("%0.5f",spdyaw*180/math.pi)..' D1:'..string.format("%0.5f",dyaw)..' D2:'..string.format("%0.5f",dyaw_rate)..' dact:'..string.format("%0.5f",delev)..' act:'..string.format("%0.5f",elev)..' dt:'..string.format("%0.5f",dt))

end

function autocoord_Vap (sqdinx,wgmainx)

	local dt = oapi.get_simstep()
	local airvelhdg

	local vhrzairvel = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.HORIZON)
	local vvslairvel = wing[sqdinx][wgmainx].vi:get_airspeedvector(REFFRAME.LOCAL)
	fwdairvel =  math.sqrt(vvslairvel.z^2+vvslairvel.y^2)* vvslairvel.z/math.abs(vvslairvel.z)* math.cos (wing[sqdinx][wgmainx].vi:get_pitch())

	pryw = wing[sqdinx][wgmainx].vi:get_yaw()

	if fwdairvel > 10 then 
		airvelhdg = math.atan2(vhrzairvel.x,vhrzairvel.z)
		if airvelhdg < 0 then airvelhdg = 2* PI + airvelhdg end
		dyw = pryw - airvelhdg
	else
		dyw = pryw-wing[sqdinx][0].tgthdg * RAD
	end
	if dyw < -PI then dyw = dyw+2*PI elseif dyw > PI then dyw = dyw-2*PI end -- phase unwrap
	rate =  (pryw - wing[sqdinx][wgmainx].yaw0)/dt
    wing[sqdinx][wgmainx].yaw0 = pryw
    if rate < -PI then rate = rate+2*PI elseif rate > PI then rate = rate-2*PI end -- phase unwrap
    dsecrot = (-rate - dyw* (1/apparam[sqdinx].coord_rud.damp))  * (dt*apparam[sqdinx].coord_rud.gain) 

	if dsecrot > 1 then dsecrot =1 elseif dsecrot < -1 then dsecrot =-1 end

	wing[sqdinx][wgmainx].secrotyaw = wing[sqdinx][wgmainx].secrotyaw + dsecrot
	if wing[sqdinx][wgmainx].secrotyaw > 1 then wing[sqdinx][wgmainx].secrotyaw =1 elseif wing[sqdinx][wgmainx].secrotyaw < -1 then wing[sqdinx][wgmainx].secrotyaw = -1 end
	
	
	if wing[sqdinx][wgmainx].secrotyaw > 0  then
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWRIGHT,wing[sqdinx][wgmainx].secrotyaw)
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWLEFT,0)
	else
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWRIGHT,0)
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_YAWLEFT,-wing[sqdinx][wgmainx].secrotyaw)
	end

	--oapi.dbg_out('arhd'..tostring(airvelhdg*DEG)..' pryw'..tostring(pryw*DEG)..' dyw'..tostring(dyw*DEG)..' rt'..tostring(rate)..' dscrt'..tostring(dsecrot))
	
end

function formzspd_ap(dz,sqdinx,wgmainx)

	local ddz 
	
	local dt = oapi.get_simstep()
	
	ddz = (dz-wing[sqdinx][wgmainx].formdz0)/dt
	wing[sqdinx][wgmainx].formdz0 = dz
	dspdtoset = ( -ddz + dz * 1/apparam[sqdinx].frmdz.damp) * apparam[sqdinx].frmdz.gain * dt
	spdtoset = wing[sqdinx][0].tgtspd + dspdtoset

	return spdtoset

end

function formxhdg_ap(dx,sqdinx,wgmainx)

local ddx,dhdgtoset, hdgtoset
local dt = oapi.get_simstep()

	ddx = (dx - wing[sqdinx][wgmainx].formdx0)/dt
	wing[sqdinx][wgmainx].formdx0 = dx
	dhdgtoset = (- ddx + dx * 1/apparam[sqdinx].frmdx.damp) * apparam[sqdinx].frmdx.gain * dt
	if dhdgtoset > 20 then dhdgtoset = 20 elseif dhdgtoset<-20 then dhdgtoset =-20 end

	hdgtoset = wing[sqdinx][0].tgthdg + dhdgtoset 
	if hdgtoset > 360 then hdgtoset = hdgtoset -360 elseif hdgtoset < 0 then hdgtoset = hdgtoset + 360 end
	return hdgtoset

end

function efp(crswpflnme, sqdinx, iniwpnumber,crsmode)


	--Enter cruise pattern

	if crswpflnme ==nil then term.out('You must enter a valid cruise path filename.') return end

	if iniwpnumber == nil or iniwpnumber < 0 then iniwpnumber = 1 end

	if crsmode == nil or crsmode =='' then crsmode = 'cruise' end
	crsmode = string.lower(crsmode)
	if string.lower(crsmode) ~='cruise' and string.lower(crsmode) ~='loop' and string.lower(crsmode) ~='land' and string.lower(crsmode) ~='takeoff' and string.lower(crsmode) ~='takeoff_and_land' then term.out('Invalid cruise mode. Valid modes are \'cruise\', \'loop\',\'land\',\'takeoff\' and \'takeoff_and_land\'') return end


	if sqdinx == nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx].crswpnum = get_crswpnts(sqdinx,crswpflnme,oapi.get_equpos(wing[sqdinx][0].hi))
	if wing[sqdinx].crswpnum == -1 then term.out('Cruise path name is invalid.') return end
	if iniwpnumber > wing[sqdinx].crswpnum then term.out('Start waypoint number is invalid. Flight plan has only '..tostring(wing[sqdinx].crswpnum)..' waypoints.') return end





	if wing[sqdinx].crswpnum == -1 then
		term.out('Could not load waypoints. Check file name is correct.')
		return
	else
		term.out('Entering flight plan '..crswpflnme..'.')
		local wpinx = 0
		while wpinx < wing[sqdinx].crswpnum do
			local hdg2show = wing[sqdinx].crswp[wpinx].hdg
			if hdg2show < 0 then hdg2show = hdg2show+ 2* math.pi end
			term.out( tostring(wpinx+1)..string.char(176)..' Leg ('..string.format("%0.2f",wing[sqdinx].crswp[wpinx].dst)..'m): '..string.format("%0.2f",hdg2show*180/math.pi)..string.char(176)..' to '..'LAT:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lat*180/math.pi)..' LON:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lng*180/math.pi)..'.')
			wpinx =wpinx +1
		end
	end

	wing[sqdinx].crswpmod = 1
	wing[sqdinx].crsmod = crsmode
	wing[sqdinx].crswpinx = iniwpnumber -1


	if wing[sqdinx][0].vi:get_groundcontact() then
			wing[sqdinx].gearsts = 1
	else
		wing[sqdinx].gearsts = -1
	end

end

function xfp(sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	wing[sqdinx].crswpnum =  -1
	wing[sqdinx].crswpinx = -1
	wing[sqdinx].crswpmod = -1
	wing[sqdinx].crsmod = 'none'
	wing[sqdinx].crswp = nil
	wing[sqdinx].gearsts = 0
	term.out('Squadron '..tostring(sqdinx)..'\'s flight plan is cancelled.')

end

function etp(tplength,sqdinx)

	if sqdinx ==nil then
		sqdinx = 0
		while wing[sqdinx] ~= nil do
			if  wing[sqdinx][0].vi == vessel.get_focusinterface() then break end
			sqdinx =sqdinx+1
		end
		if wing[sqdinx] == nil then term.out('Squadron not found. Check focus plane is a squadron leader.') return end
	else
		if wing[sqdinx] == nil then term.out('Squadron number is invalid. No such squadron exists.') return end
	end

	if tplength == nil then tplength = 40000 end
	if tplength < 40000 then  term.out('Traffic pattern length should be more than 40000m.') return end

	presentpos = oapi.get_equpos(wing[sqdinx][0].hi)

	tpassy(sqdinx,wing[sqdinx][0].tgthdg*math.pi/180,wing[sqdinx][0].tgtspd,presentpos,tplength)
	wing[sqdinx].crswpinx = 0
	wing[sqdinx].crswpnum = 10
	wing[sqdinx].crswpmod = 1
	wing[sqdinx].crsmod = 'loop'
	term.out('Entering traffic pattern .')
end

function tpassy(sqdinx,sqdhdg,vel,presentpos,tplength)

	local planetradius = oapi.get_size(hplanet)
	local coords = {lat=0,lng=0}
	local centerradpoint =  {lat=0,lng=0}
	local radius = vel/math.pi*120 -- 4 min turns

	term.out('Assembling traffic pattern')
	wing[sqdinx].crswp = {}
	wing[sqdinx].crswp[9] = {}
	wing[sqdinx].crswp[9].lat = presentpos.lat
	wing[sqdinx].crswp[9].lng = presentpos.lng
	local turnmidang = sqdhdg - math.pi/2
	if turnmidang > math.pi then turnmidang = turnmidang - 2* math.pi end
	if turnmidang < -math.pi then turnmidang = turnmidang + 2* math.pi end
	centerradpoint = equfromroute(presentpos,turnmidang,radius)
	if turnmidang > math.pi then turnmidang = turnmidang - 2* math.pi end
	if turnmidang < -math.pi then turnmidang = turnmidang + 2* math.pi end
	local wpinx = 0
	while wpinx < 4 do
		turnmidang= sqdhdg + math.pi/2 - ((wpinx+1) * math.pi/4)
		if turnmidang > math.pi then turnmidang = turnmidang - 2* math.pi end
		if turnmidang < -math.pi then turnmidang = turnmidang +2* math.pi end

		coords = equfromroute(centerradpoint,turnmidang,radius)
		wing[sqdinx].crswp[wpinx] ={}
		wing[sqdinx].crswp[wpinx].lat = coords.lat
		wing[sqdinx].crswp[wpinx].lng = coords.lng
		--term.out(tostring(wpinx)..'- LAT:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lat*180/math.pi)..' LON:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lng*180/math.pi))
		wpinx = wpinx+1

	end

	turnmidang = sqdhdg - math.pi
	if turnmidang > math.pi then turnmidang = turnmidang -2*  math.pi end
	if turnmidang < -math.pi then turnmidang = turnmidang +2* math.pi end
	coords = equfromroute(wing[sqdinx].crswp[wpinx-1],turnmidang,tplength)
	wing[sqdinx].crswp[wpinx] ={}
	wing[sqdinx].crswp[wpinx].lat = coords.lat
	wing[sqdinx].crswp[wpinx].lng = coords.lng
	--term.out(tostring(wpinx)..'- LAT:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lat*180/math.pi)..' LON:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lng*180/math.pi))



	sqdhdg = turnmidang
	local turnmidang = sqdhdg - math.pi/2
	if turnmidang > math.pi then turnmidang = turnmidang -2* math.pi end
	if turnmidang < -math.pi then turnmidang = turnmidang +2* math.pi end
	centerradpoint = equfromroute(wing[sqdinx].crswp[wpinx],turnmidang,radius)
	local turnmidang = sqdhdg + math.pi/2
	if turnmidang > math.pi then turnmidang = turnmidang - 2* math.pi end
	if turnmidang < -math.pi then turnmidang = turnmidang + 2* math.pi end

	wpinx = wpinx+1
	while wpinx < 9 do
		turnmidang= sqdhdg + math.pi/2 - ((wpinx-4) * math.pi/4)
		if turnmidang > math.pi then turnmidang = turnmidang - 2* math.pi end
		if turnmidang < -math.pi then turnmidang = turnmidang +2* math.pi end

		coords = equfromroute(centerradpoint,turnmidang,radius)
		wing[sqdinx].crswp[wpinx] ={}
		wing[sqdinx].crswp[wpinx].lat = coords.lat
		wing[sqdinx].crswp[wpinx].lng = coords.lng
		--term.out(tostring(wpinx)..'- LAT:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lat*180/math.pi)..' LON:'..string.format("%0.4f",wing[sqdinx].crswp[wpinx].lng*180/math.pi))
		wpinx = wpinx+1
	end



	wing[sqdinx].crswp[0].dst, wing[sqdinx].crswp[0].hdg = distandcoursebetweentwopoints( wing[sqdinx].crswp[9], wing[sqdinx].crswp[0] )
			term.out('0- DST:'..string.format("%0.4f",wing[sqdinx].crswp[0].dst)..' HDG:'..string.format("%0.4f",wing[sqdinx].crswp[0].hdg*180/math.pi))
	wpinx = 1
	while wpinx < 10 do
		wing[sqdinx].crswp[wpinx].dst, wing[sqdinx].crswp[wpinx].hdg = distandcoursebetweentwopoints( wing[sqdinx].crswp[wpinx-1], wing[sqdinx].crswp[wpinx] )
		wing[sqdinx].crswp[wpinx].dst = wing[sqdinx].crswp[wpinx].dst * planetradius
		wpinx = wpinx+1
	end

	hdig1 = wing[sqdinx].crswp[4].hdg
	if hdig1 < 0 then hdig1 = hdig1 +2*math.pi end
	hdig2 = wing[sqdinx].crswp[9].hdg
	if hdig2 < 0 then hdig2 = hdig2 +2*math.pi end
	term.out(' Length:'..string.format("%0.4f",wing[sqdinx].crswp[4].dst)..' Headings:'..string.format("%0.4f",hdig1*180/math.pi)..' '..string.format("%0.4f",hdig2*180/math.pi))


end

function clearATTthgroups(sqdinx,wgmainx)
	--Turns all attitude thrusters OFF 
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_PITCHUP,0)
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_PITCHDOWN,0)
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_BANKLEFT,0)
		wing[sqdinx][wgmainx].vi:set_thrustergrouplevel (THGROUP.ATT_BANKRIGHT,0)
end

function lowerraiseGear(sqdinx,wgmainx)

	if wing[sqdinx].gearsts == 0 then return end
	if vessel.get_focusinterface() == wing[sqdinx][wgmainx].vi  then oapi.simulatebufferedkey(OAPI_KEY.G) end
	wing[sqdinx].gearsts = wing[sqdinx].gearsts * -1

end

function getcurCGheight(sqdinx,wgmainx)
	local fp1,fp2,fp3 = wing[sqdinx][wgmainx].vi:get_touchdownpoints()
	local medhgt = -(fp1.y+fp2.y+fp3.y)/3
	return medhgt
end

function wkp(sqdinx,wgmainx)

	local vsslFormpos = {x=0, y=0, z=0}

	local rcounter = 0 --TESTE
	local eltim = 0 --TESTE
	local maxzeitgeist = 0 --TESTE

		while true do

			local simdt = oapi.get_simstep()


			rcounter = rcounter+1
			eltim =eltim+simdt
			zeitgeist= simdt/(eltim/rcounter) --TESTE
			if zeitgeist > maxzeitgeist then maxzeitgeist = zeitgeist end --TESTE

			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'timestep' then
				dbgstr = 'simdt/mean(past_simdts):'..tostring(zeitgeist)..' Max simdt/mean(past_simdts):'..tostring(maxzeitgeist) --TESTE
				if simdt > discard_step_simdt_criteria * eltim/rcounter then dbgstr = dbgstr..' SKIPPED' end
				oapi.dbg_out(dbgstr)
			end

			if simdt > discard_step_simdt_criteria * eltim/rcounter then proc.skip() end



			if wgmainx==0 then

				local presentpos = oapi.get_equpos(wing[sqdinx][0].hi)

				--Predecision: from cruise mode conditions determinate waypoint  mode and set initial wp conds
				--************
				if wing[sqdinx].crsmod == 'none' then
					wing[sqdinx].crswpmod = -1
				elseif wing[sqdinx].crsmod == 'cruise' or wing[sqdinx].crsmod == 'loop' then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
				elseif wing[sqdinx].crsmod == 'takeoff' or wing[sqdinx].crsmod == 'takeoff_and_land'then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
					if wing[sqdinx].crswpmod == 1 then
						if wing[sqdinx].crswpinx == 0 then
							if wing[sqdinx][0].vi:get_groundcontact() then
								wing[sqdinx].crswpmod = 4
								crittodirect = 10000
								wing[sqdinx][0].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD) + apparam[sqdinx].limits.takeoffmaxasc / hardcoded_dalt_to_slope
								wing[sqdinx][0].tgtspd = math.huge
							end
						end

					elseif wing[sqdinx].crswpmod == 4 then
						if wing[sqdinx].crswpinx == 0 then
							if wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND) > wing[sqdinx][0].tgtalt *.5 then
								if wing[sqdinx].crsmod == 'takeoff' then
										wing[sqdinx].crsmod = 'cruise'
								elseif wing[sqdinx].crsmod == 'takeoff_and_land' then
									wing[sqdinx].crsmod = 'land'
								end
								wing[sqdinx].crswpmod = 1
								crittodirect = 10000
								wing[sqdinx][0].tgtalt = wing[sqdinx].crswp[0].alt
							end
						end
					end

				elseif wing[sqdinx].crsmod == 'land' then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
					if wing[sqdinx].crswpmod == 1 then
						if wing[sqdinx].crswpinx >= wing[sqdinx].crswpnum -2 then
							wing[sqdinx].crswpmod = 6
							crittodirect = 5000
						end

					elseif wing[sqdinx].crswpmod == 6 then 
						if wing[sqdinx].crswpinx == wing[sqdinx].crswpnum -1 then
							hLandNav = wing[sqdinx][0].vi:get_navsource(0)

							if hLandNav ~= nil then 
								if oapi.get_navtype(hLandNav) == TRANSMITTER.ILS then

									LandNavdata = oapi.get_navdata(hLandNav)
									if LandNavdata.appdir > math.pi then LandNavdata.appdir  = LandNavdata.appdir  -2 * math.pi end
									equLandNavpos = oapi.global_to_equ(hplanet,oapi.get_navpos(hLandNav))

									equLandNavBase = oapi.global_to_equ(hplanet,oapi.get_globalpos(LandNavdata.hbase)) 
									LandNavalt = equLandNavBase.rad - oapi.get_size(hplanet)

									LandNavdist,LandNavhdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng = equLandNavpos.lng,lat = equLandNavpos.lat} )
									if LandNavdist *  oapi.get_size(hplanet) < 100000 and  math.abs(LandNavhdg - LandNavdata.appdir ) < math.pi/18  then
										local altabvLandNav = wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND)
										if altabvLandNav > .75 * math.tan(2.5*math.pi/180) * LandNavdist and altabvLandNav < LandNavalt +1010 and wing[sqdinx][0].vi:get_airspeed() < 170 then -- Is .5M reasonable?
											if wing[sqdinx].gearsts == -1 then lowerraiseGear(sqdinx,0) end --GEAR
											term.out('Auto Landing engaged for squadron '..tostring(sqdinx)..' to '..LandNavdata.descr..'.')
											sf('line astern',sqdinx)
											wing[sqdinx].crswpmod = 7
											crittodirect = 1000
										end
									end
								end
							end
						end

					elseif wing[sqdinx].crswpmod == 7  then
						if wing[sqdinx][0].vi:get_navsource(0) == nil then 
							wing[sqdinx].crswpmod = 6
							crittodirect = 5000
						end

					end
				end

				--Mode Distribution
				--*****************
				if wing[sqdinx].crswpmod == -1 then --default no flight plan cruise
					wing[sqdinx][0].tgthdg = wing[sqdinx][0].tgthdg + wing[sqdinx].headrate * oapi.get_simstep()
					if wing[sqdinx][0].tgthdg > 360 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg - 360 end
					if wing[sqdinx][0].tgthdg < 0 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg + 360 end
					
				elseif wing[sqdinx].crswpmod == 1 or wing[sqdinx].crswpmod == 0 or wing[sqdinx].crswpmod == 7 or wing[sqdinx].crswpmod == 6 or wing[sqdinx].crswpmod ==  4 then --flight plan cruises
					
					--flight plan cruise heading handling
					--************************************
					local dhdgdf_1 = wpdist/75000
					if dhdgdf_1 >1 then dhdgdf_1 =1 end
					if dhdgdf_1 <.5 then dhdgdf_1 =.5 end
					local dhdgdf_2 = 6
					dhdg = wphdg-wing[sqdinx].crswp[wing[sqdinx].crswpinx].hdg
					if dhdg < -math.pi then dhdg = dhdg + 2* math.pi end
					if dhdg > math.pi then dhdg = dhdg - 2* math.pi end

					if wpdist < crittodirect or dhdg > math.pi/2 or dhdg < -math.pi/2 then
						helmcomm = wphdg
					else
						if dhdg > math.pi/2/dhdgdf_2 then dhdg = math.pi/2/dhdgdf_2 end
						if dhdg < -math.pi/2/dhdgdf_2 then dhdg = -math.pi/2/dhdgdf_2 end
						helmcomm  = wing[sqdinx].crswp[wing[sqdinx].crswpinx].hdg + dhdgdf_1 * dhdgdf_2 *dhdg
						if helmcomm <- math.pi then helmcomm = 2* math.pi + helmcomm end
						if helmcomm > 2* math.pi then helmcomm = helmcomm - 2* math.pi end
					end
					wing[sqdinx][0].tgthdg = helmcomm *180/math.pi
				end
				

					--flight plan waypoint slope handling
					--************************************
				if wing[sqdinx].crswpmod == 4 then --takeoff slope
					--already set
				elseif wing[sqdinx].crswpmod == 6 then --landing slope
					wing[sqdinx][0].pitch0,dpitchrate,isAOA = get_pitchandpitchrateandAOA(sqdinx,0,simdt)
					wing[sqdinx][0].tgtalt = wing[sqdinx].crswp[wing[sqdinx].crswpnum-2].alt

				elseif wing[sqdinx].crswpmod == 7 then --landing slope
					hLandNav = wing[sqdinx][0].vi:get_navsource(0)
					if hLandNav ~= nil then 
						LandNavdata = oapi.get_navdata(hLandNav)
						if LandNavdata.type == TRANSMITTER.ILS then
							equLeadpos = oapi.global_to_equ(hplanet,wing[sqdinx][0].vi:get_globalpos())
							equLandNavpos = oapi.global_to_equ(hplanet,oapi.get_navpos(hLandNav))
							equLandNavBase = oapi.global_to_equ(hplanet,oapi.get_globalpos(LandNavdata.hbase)) 
							LandNavalt = equLandNavBase.rad -oapi.get_size(hplanet)
							equLandNavpos.rad = equLandNavpos.rad + LandNavalt
							plncartLandNavpos = plnequ2plncart(equLandNavpos)
							plncartLeadpos = plnequ2plncart(equLeadpos)
							plncartLeadtoNavpos = vec.sub(plncartLandNavpos,plncartLeadpos)
							LHLVLeadtoNavpos = plncart2LHLV(plncartLeadtoNavpos,wing[sqdinx][0].hi)
							wing[sqdinx][0].pitch0,dpitchrate,isAOA = get_pitchandpitchrateandAOA(sqdinx,0,simdt)
							local gnddsttowp = math.sqrt(LHLVLeadtoNavpos.x^2+LHLVLeadtoNavpos.z^2)
							local slopetowp = -math.atan2( LHLVLeadtoNavpos.y,gnddsttowp)
							desiredalt = math.tan(2.5*math.pi/180)*gnddsttowp + getcurCGheight(sqdinx,0) + LandNavalt
							dglalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD) - desiredalt
							if dglalt  > apparam[sqdinx].limits.maxasc / hardcoded_dalt_to_slope then dglalt = apparam[sqdinx].limits.maxasc / hardcoded_dalt_to_slope end
							if dglalt < apparam[sqdinx].limits.maxdsc / hardcoded_dalt_to_slope then dglalt = apparam[sqdinx].limits.maxdsc / hardcoded_dalt_to_slope end
							wing[sqdinx][0].tgtalt = wing[sqdinx][0].tgtalt -(dpitchrate + dglalt * 1/apparam[sqdinx].autoland_alt.damp ) * apparam[sqdinx].autoland_alt.gain * simdt --*PARAM*01 *PARAM*02  autoland_alt.damp
							if wing[sqdinx][0].tgtalt > 1000 + LandNavalt then wing[sqdinx][0].tgtalt = 1000 + LandNavalt end

							if DEBUG.squadron == sqdinx and DEBUG.wingman == 0 and DEBUG.mode== 'autoland' then oapi.dbg_out('leader from squadron:'..tostring(sqdinx)..' dpitchrate:'..string.format("%0.4f",dpitchrate)..' slopetowp/(2.5dg):'..string.format("%0.4f",slopetowp*72/math.pi)..' 2.5dg slope desired alt:'..string.format("%0.4f",desiredalt)..' ap tgtalt :'..string.format("%0.4f",wing[sqdinx][0].tgtalt)..' ap tgtspd :'..string.format("%0.4f",wing[sqdinx][0].tgtspd) ) end

						else
							wing[sqdinx].crswpmode = 1
						end
					else
						wing[sqdinx].crswpmode = 1
					end
				end

				
				
				--flight plan waypoint speed handling
				--************************************
				if wing[sqdinx].crswpmod == 4  then--taking off
					if wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND) > getcurCGheight(sqdinx,0) + 10 then 
						if wing[sqdinx].gearsts == 1 then
							lowerraiseGear(sqdinx,0) 
							wing[sqdinx][0].tgtspd = airspeed(sqdinx,0)
						end 
					end
					
					
				elseif wing[sqdinx].crswpmod == 6  then--landing 

					wing[sqdinx][0].tgtspd = wing[sqdinx][0].tgtspd - (dpitchrate + ( 5 - isAOA*180/math.pi)* 1/apparam[sqdinx].autoland_spd.damp) * apparam[sqdinx].autoland_spd.gain * simdt --*PARAM*03 *PARAM*04 autoland_spd

					if wing[sqdinx][0].tgtspd  < 30 then wing[sqdinx][0].tgtspd = 30 end --60 knots: a small plane stall
					if wing[sqdinx][0].tgtspd  >125 then wing[sqdinx][0].tgtspd = 125 end --250knots top speed below 10k 
					
				elseif wing[sqdinx].crswpmod == 7 then 
				
					wing[sqdinx][0].tgtspd = wing[sqdinx][0].tgtspd - (dpitchrate + ( 5 + 2.5 - isAOA*180/math.pi)* 1/apparam[sqdinx].autoland_spd.damp) * apparam[sqdinx].autoland_spd.gain * simdt --*PARAM*03 *PARAM*04 autoland_spd

					if wing[sqdinx][0].tgtspd  < 30 then wing[sqdinx][0].tgtspd = 30 end --60 knots: a small plane stall
					if wing[sqdinx][0].tgtspd  >125 then wing[sqdinx][0].tgtspd = 125 end --250knots top speed below 10k 

					if wpdist < 100 then
						wing[sqdinx][0].vi:set_thrustergrouplevel (THGROUP.MAIN, 0)
						wing[sqdinx][0].tgtspd = 0 
					end
				
				end


				--flight plan waypoint sequence updating
				--************************************
				if wing[sqdinx].crswpmod == 1 or wing[sqdinx].crswpmod == 6 then
					if wpdist < 2000 then wing[sqdinx].crswpinx = wing[sqdinx].crswpinx +1 end
				elseif wing[sqdinx].crswpmod == 7 then 
					if wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND) < 1.2* getcurCGheight(sqdinx,0) then
						wing[sqdinx].crswpinx = wing[sqdinx].crswpinx +1 --to end
					end
				end

				--flight plan compleition measures
				--*********************************
				if wing[sqdinx].crswpinx == wing[sqdinx].crswpnum  then
					if  wing[sqdinx].crsmod == 'cruise' then
						xfp(sqdinx)
					elseif wing[sqdinx].crsmod == 'loop' then
						wing[sqdinx].crswpinx = 0
					elseif wing[sqdinx].crsmod == 'land' then
						wing[sqdinx][wgmainx].tgtspd = -100
						wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)
						xfp(sqdinx)
					end
				end

			else --wingmen behaviour

				--Default setup: same as leader

				wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].tgtalt
				wing[sqdinx][wgmainx].tgtspd = wing[sqdinx][0].tgtspd
				wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][0].tgthdg

				--Ideal vessel vector position in formation

				FormDX = math.cos(wing[sqdinx].Formangle * math.pi/180) * wing[sqdinx].Forminterval
				FormDZ = math.sin(wing[sqdinx].Formangle * math.pi/180) * wing[sqdinx].Forminterval

				vsslFormpos.x = wing[sqdinx][wgmainx].Formseq[1] * FormDX
				vsslFormpos.z = wing[sqdinx][wgmainx].Formseq[2] * FormDZ 
				vsslFormpos.y = 0

				--wingman position respective to leader.

				glpos = wing[sqdinx][wgmainx].vi:get_relativepos(wing[sqdinx][0].hi)
				plntcartpos = sunglb2plncart4orient(hplanet,glpos)
				LHLVpos = plncart2LHLV(plntcartpos,wing[sqdinx][0].hi)
				vsslpos = LHLV2vssl(LHLVpos,wing[sqdinx][0].vi)

				vsslFormdif = vec.sub(vsslFormpos,vsslpos)

				--formation adjustments for the wingman

				wing[sqdinx][wgmainx].tgtspd = formzspd_ap(vsslFormdif.z,sqdinx,wgmainx)
				if wing[sqdinx][wgmainx].tgtspd <0 then wing[sqdinx][wgmainx].tgtspd =0 end
				if wing[sqdinx][0].tgtspd < 0 then --landing provision
					if wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND) < 1.2* getcurCGheight(sqdinx,wgmainx) then wing[sqdinx][wgmainx].tgtspd = -100 end
				end

				wing[sqdinx][wgmainx].tgthdg = formxhdg_ap(vsslFormdif.x,sqdinx,wgmainx)

			end

			spd_ap(wing[sqdinx][wgmainx].tgtspd,sqdinx,wgmainx)

			if airspeed(sqdinx,wgmainx)>25 then -- so it does not set all surfaces to extremes when resting landed

			wing[sqdinx][wgmainx].tgtslope = BAR_alt_ap(wing[sqdinx][wgmainx].tgtalt,sqdinx,wgmainx)
			slope_ap(wing[sqdinx][wgmainx].tgtslope,sqdinx,wgmainx)

			if wing[sqdinx][wgmainx].vi:get_altitude(ALTMODE.GROUND) > 100 then --so it does not bank during takeoff run
				wing[sqdinx][wgmainx].tgtbnk = heading_ap(wing[sqdinx][wgmainx].tgthdg,sqdinx,wgmainx)
				bank_ap(wing[sqdinx][wgmainx].tgtbnk,sqdinx,wgmainx)
			else
				bank_ap(0,sqdinx,wgmainx)
				yaw_ap(wing[sqdinx][wgmainx].tgthdg,sqdinx,wgmainx)
			end

			autocoord_ap(sqdinx,wgmainx)
		end

			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'rotors' then oapi.dbg_out('This is a HTOL squadron.') end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'surfaces' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'Elevator:'..string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.ELEVATOR))..'Airelons:'..string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.AILERON))..'Rudder:'..string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_adclevel(AIRCTRL.RUDDER))..'Thrust:'..string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel (THGROUP.MAIN))) end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'formz' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'diffrmposz:'..string.format("%0.3f",vsslFormdif.z)..'tgtspd:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgtspd)) end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'formx' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'diffrmposx:'..string.format("%0.3f",vsslFormdif.x)..'tgtbnk:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgtbnk)..'tgthdg:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgthdg)) end

			proc.skip()

		end
end

function Vwkp(sqdinx,wgmainx)

	local vsslFormpos = {x=0, y=0, z=0}

	local rcounter = 0 --TESTE
	local eltim = 0 --TESTE
	local maxzeitgeist = 0 --TESTE

		while true do

			local simdt = oapi.get_simstep()


			rcounter = rcounter+1
			eltim =eltim+simdt
			zeitgeist= simdt/(eltim/rcounter) --TESTE
			if zeitgeist > maxzeitgeist then maxzeitgeist = zeitgeist end --TESTE

			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'timestep' then
				dbgstr = 'simdt/mean(past_simdts):'..tostring(zeitgeist)..' Max simdt/mean(past_simdts):'..tostring(maxzeitgeist) --TESTE
				if simdt > discard_step_simdt_criteria * eltim/rcounter then dbgstr = dbgstr..' SKIPPED' end
				oapi.dbg_out(dbgstr)
			end

			if simdt > discard_step_simdt_criteria * eltim/rcounter then proc.skip() end



			if wgmainx==0 then
				
				local presentpos = oapi.get_equpos(wing[sqdinx][0].hi)

				--Predecision: from cruise mode conditions determinate waypoint  mode and set initial wp conds
				--************
				if wing[sqdinx].crsmod == 'none' then
					wing[sqdinx].crswpmod = -1


				elseif wing[sqdinx].crsmod == 'cruise' or wing[sqdinx].crsmod == 'loop' then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
					
					
				elseif wing[sqdinx].crsmod == 'takeoff' or wing[sqdinx].crsmod == 'takeoff_and_land' then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
					if wing[sqdinx].crswpmod == 1 then --takeoff
						if wing[sqdinx].crswpinx == 0 then
							if wing[sqdinx][0].vi:get_groundcontact() then
								wing[sqdinx].crswpmod = 4
								crittodirect = 10000
								wing[sqdinx][0].tgtalt = wing[sqdinx].crswp[wing[sqdinx].crswpinx].alt
								wing[sqdinx][0].tgtspd = 0
							end
						end
					
					elseif wing[sqdinx].crswpmod == 4 then
						if wing[sqdinx].crswpinx == 0 then
							if wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD) > wing[sqdinx][0].tgtalt *.9 then
								if wing[sqdinx].crsmod == 'takeoff' then
										wing[sqdinx].crsmod = 'cruise'
								elseif wing[sqdinx].crsmod == 'takeoff_and_land' then
									wing[sqdinx].crsmod = 'land'
								end
								wing[sqdinx].crswpmod = 1
								crittodirect = 10000
								wing[sqdinx][0].tgtalt = wing[sqdinx].crswp[0].alt
								wing[sqdinx][0].tgtspd = 30
							end
						end
					end
				
				elseif wing[sqdinx].crsmod == 'land' then
					wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
					wpdist = wpdist * oapi.get_size(hplanet)
					crittodirect = 10000
					if wing[sqdinx].crswpmod == 1 then
						if wing[sqdinx].crswpinx >= wing[sqdinx].crswpnum - 1 then
							wing[sqdinx].crswpmod = 6 --approach :reduce speed to zero
							crittodirect = 100
						end
				
					elseif wing[sqdinx].crswpmod == 6 then 
						wpdist,wphdg = distandcoursebetweentwopoints({lng= presentpos.lng, lat = presentpos.lat},{lng= wing[sqdinx].crswp[wing[sqdinx].crswpinx].lng,lat = wing[sqdinx].crswp[wing[sqdinx].crswpinx].lat})
						wpdist = wpdist * oapi.get_size(hplanet)
						if wpdist < 10 then
							wing[sqdinx].crswpmod = 7
							wing[sqdinx][0].tgthdg = wing[sqdinx].crswp[wing[sqdinx].crswpinx].hdg *180/math.pi
							
						end

					end
				
				end

				--Mode Distribution
				--*****************
				if wing[sqdinx].crswpmod == -1 then --default no flight plan cruise
					wing[sqdinx][0].tgthdg = wing[sqdinx][0].tgthdg + wing[sqdinx].headrate * oapi.get_simstep()
					if wing[sqdinx][0].tgthdg > 360 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg - 360 end
					if wing[sqdinx][0].tgthdg < 0 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg + 360 end
				
				elseif wing[sqdinx].crswpmod == 1 or wing[sqdinx].crswpmod == 0 or wing[sqdinx].crswpmod == 6 or wing[sqdinx].crswpmod ==  4 then --flight plan cruises
					
					--flight plan cruise heading handling
					--************************************
					local dhdgdf_1 = wpdist/75000
					if dhdgdf_1 >1 then dhdgdf_1 =1 end
					if dhdgdf_1 <.5 then dhdgdf_1 =.5 end
					local dhdgdf_2 = 6
					dhdg = wphdg-wing[sqdinx].crswp[wing[sqdinx].crswpinx].hdg
					if dhdg < -math.pi then dhdg = dhdg + 2* math.pi end
					if dhdg > math.pi then dhdg = dhdg - 2* math.pi end

					if wpdist < crittodirect or dhdg > math.pi/2 or dhdg < -math.pi/2 then
						helmcomm = wphdg
					else
						if dhdg > math.pi/2/dhdgdf_2 then dhdg = math.pi/2/dhdgdf_2 end
						if dhdg < -math.pi/2/dhdgdf_2 then dhdg = -math.pi/2/dhdgdf_2 end
						helmcomm  = wing[sqdinx].crswp[wing[sqdinx].crswpinx].hdg + dhdgdf_1 * dhdgdf_2 *dhdg
						if helmcomm <- math.pi then helmcomm = 2* math.pi + helmcomm end
						if helmcomm > 2* math.pi then helmcomm = helmcomm - 2* math.pi end
					end
					wing[sqdinx][0].tgthdg = helmcomm *180/math.pi
				end



					--flight plan waypoint slope handling
					--************************************
				if wing[sqdinx].crswpmod == 4 then --takeoff 
					--already set
				elseif wing[sqdinx].crswpmod == 6 then --landing speed reduction

				elseif wing[sqdinx].crswpmod == 7 then --landing slope
					wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].vi:get_altitude(ALTMODE.MEANRAD)- wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND)
				end


				--flight plan waypoint speed handling
				--************************************
				if wing[sqdinx].crswpmod == 4  then--taking off
					wing[sqdinx][0].tgtspd = 0
				elseif wing[sqdinx].crswpmod == 6  then--approach to landing 
					if wing[sqdinx][0].tgtspd > wpdist * 40/1000 then wing[sqdinx][0].tgtspd = wpdist * 40/1000 end
				elseif wing[sqdinx].crswpmod == 7  then--landing 
					wing[sqdinx][0].tgtspd =0
				end


				--flight plan waypoint sequence updating
				--************************************

				if wing[sqdinx].crswpmod == 1 then
					if wpdist < 2000 then wing[sqdinx].crswpinx = wing[sqdinx].crswpinx +1 end
				elseif wing[sqdinx].crswpmod == 7 then
					if wing[sqdinx][0].vi:get_altitude(ALTMODE.GROUND) < getcurCGheight(sqdinx,0) + 1 then
						wing[sqdinx].crswpinx = wing[sqdinx].crswpnum -- finish
					end
				end
				

				--flight plan compleition measures
				--*********************************
				if wing[sqdinx].crswpinx == wing[sqdinx].crswpnum  then
					if  wing[sqdinx].crsmod == 'cruise' then
						xfp(sqdinx)
					elseif wing[sqdinx].crsmod == 'loop' then
						wing[sqdinx].crswpinx = 0
					elseif wing[sqdinx].crsmod == 'land' then
						wing[sqdinx][wgmainx].tgtalt = 0
						xfp(sqdinx)
					end
				end

				--oapi.dbg_out(tostring(wing[sqdinx].crswpmod)..' '..tostring(wing[sqdinx].crswpinx)..' '..tostring(wpdist)..' '..tostring(wing[sqdinx].crswpnum)..' '..tostring(wing[sqdinx][0].tgtspd))

			else --wingmen behaviour

				--Default setup: same as leader

				wing[sqdinx][wgmainx].tgtalt = wing[sqdinx][0].tgtalt
				wing[sqdinx][wgmainx].tgtspd = wing[sqdinx][0].tgtspd
				wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][0].tgthdg

				--Ideal vessel vector position in formation

				FormDX = math.cos(wing[sqdinx].Formangle * math.pi/180) * wing[sqdinx].Forminterval
				FormDZ = math.sin(wing[sqdinx].Formangle * math.pi/180) * wing[sqdinx].Forminterval

				vsslFormpos.x = wing[sqdinx][wgmainx].Formseq[1] * FormDX
				vsslFormpos.z = wing[sqdinx][wgmainx].Formseq[2] * FormDZ 
				vsslFormpos.y = 0

				--wingman position respective to leader in the leader vessel frame

				glpos = wing[sqdinx][wgmainx].vi:get_relativepos(wing[sqdinx][0].hi)
				plntcartpos = sunglb2plncart4orient(hplanet,glpos)
				LHLVpos = plncart2LHLV(plntcartpos,wing[sqdinx][0].hi)
				vsslpos = LHLV2vssl(LHLVpos,wing[sqdinx][0].vi)

				--vector to formation position in the leader vessel frame
				vsslFormdif = vec.sub(vsslFormpos,vsslpos)

				--formation adjustments for the wingman

				wing[sqdinx][wgmainx].tgtspd = formzspd_ap(vsslFormdif.z,sqdinx,wgmainx)

				LHLVFormdif = vssl2LHLV(wing[sqdinx][0].vi,vsslFormdif)
				wing[sqdinx][wgmainx].tgthdg = formxhdg_ap(vsslFormdif.x,sqdinx,wgmainx)
				if wing[sqdinx][wgmainx].tgthdg >360 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg - 360 end
				if wing[sqdinx][wgmainx].tgthdg < 0 then wing[sqdinx][wgmainx].tgthdg = wing[sqdinx][wgmainx].tgthdg + 360 end

			end
		--Turns all attitude thrusters OFF
		--Due to the shared nature of Attitude thrusters, independent command settings are kept in variables
		--and their components assembled here.
		--speed -> pitch  // alt // heading -> bank //autocoord 
		
			clearATTthgroups(sqdinx,wgmainx) 
			wing[sqdinx][wgmainx].tgtptc =  speed_Vap (wing[sqdinx][wgmainx].tgtspd,sqdinx,wgmainx)
			pitch_Vap (wing[sqdinx][wgmainx].tgtptc ,sqdinx,wgmainx)
			BAR_alt_Vap(wing[sqdinx][wgmainx].tgtalt,sqdinx,wgmainx)
			wing[sqdinx][wgmainx].tgtbnk = heading_ap(wing[sqdinx][wgmainx].tgthdg,sqdinx,wgmainx)
			bank_Vap(wing[sqdinx][wgmainx].tgtbnk,sqdinx,wgmainx)
			autocoord_Vap (sqdinx,wgmainx)

			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'surfaces' then oapi.dbg_out('This is a VTOL squadron.') end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'rotors' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'tgthdg:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgthdg)..'tgtspd:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgtspd)..'sc_rt:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_YAWRIGHT))..'sc_lf:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_YAWLEFT))..'mn_lf:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_BANKLEFT))..'mn_rt:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_BANKRIGHT))..'tgt_pt:'.. string.format("%0.3f",wing[sqdinx][wgmainx].tgtptc)..'mn_up:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_PITCHUP))..'mn_dn:'.. string.format("%0.3f",wing[sqdinx][wgmainx].vi:get_thrustergrouplevel(THGROUP.ATT_PITCHDOWN))) end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'formz' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'diffrmposz:'..string.format("%0.3f",vsslFormdif.z)..'tgtspd:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgtspd)) end
			if DEBUG.squadron == sqdinx and DEBUG.wingman == wgmainx and DEBUG.mode == 'formx' then oapi.dbg_out('Sqd:'..tostring(DEBUG.squadron)..'Wgm:'..tostring(DEBUG.wingman)..'diffrmposx:'..string.format("%0.3f",vsslFormdif.x)..'tgtbnk:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgtbnk)..'tgthdg:'..string.format("%0.3f",wing[sqdinx][wgmainx].tgthdg)) end
			proc.skip()

		end
end



term.out('****************************************')
term.out('*     Formation Autopilot (V0.32)      *')
term.out('*         =Functions Loaded=           *')
term.out('*                                      *')
term.out('* Enter "help()" for a functions list  *')
term.out('****************************************')


